<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

// Check if the file is accessed only via index.php if not stop the script from running
if (!defined('JAK_ADMIN_PREVENT_ACCESS')) die('You cannot access this file directly.');

// Check if the user has access to this file
if (!JAK_USERID_CMS || !$JAK_MODULEM) jak_redirect(BASE_URL);

// All the tables we need for this plugin
$errors = array();
$jaktable = DB_PREFIX.'categories';


// We need that for all
$JAK_CAT = jak_get_cat_info($jaktable, 1);

// Now start with the plugin use a switch to access all pages
switch ($page1) {

	case 'sub':
		
			// Call the template
			$template = 'subcategories.php';
		
	break;
	case 'subsub':
		
			// Call the template
			$template = 'subsubcategories.php';
		
	break;
	case 'newcat':
		
		// Additional DB Information
		$jakfield = 'varname';
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		    $defaults = $_POST;
		
		    if (empty($defaults['jak_name'])) {
		        $errors['e1'] = $tl['error']['e12'];
		    }
		    
		    if (jak_field_not_exist($defaults['jak_varname'],$jaktable,$jakfield) || jak_varname_blocked($defaults['jak_varname'])) {
		        $errors['e2'] = $tl['error']['e13'];
		    }
		    
		    if (empty($defaults['jak_varname']) || !preg_match('/^([a-z-_0-9]||[-_])+$/', $defaults['jak_varname'])) {
		        $errors['e3'] = $tl['error']['e14'];
		    }
		        
		    if (count($errors) == 0) {
		    
		    if (!isset($defaults['jak_menu'])) {
		    	$menu = 0;
		    } else {
		    	$menu = $defaults['jak_menu'];
		    }
		    if (!isset($defaults['jak_footer'])) {
		    	$footer = 0;
		    } else {
		    	$footer = $defaults['jak_footer'];
		    }
		    
		    if (!isset($defaults['jak_permission'])) {
		    	$permission = 0;
		    } else {
		    	$permission = join(',', $defaults['jak_permission']);
		    }
		    
		    if ($defaults['jak_catparent2']) {
		    
		    	$sql3 = 'SELECT catparent FROM '.$jaktable.' WHERE id = "'.$defaults['jak_catparent2'].'"';
		    	$result3 = $jakdb->query($sql3);
		    	$row3 = $result3->fetch_assoc();
		    
		    	$sqladd = ', catparent = "'.$row3['catparent'].'",catparent2 = "'.$defaults['jak_catparent2'].'"';
		    	
		    	// Update categories table so if any sub-sub exist move them with the new sub menu
		    	$sql2 = 'UPDATE '.$jaktable.' SET subsubexist = 1 WHERE id = "'.smartsql($defaults['jak_catparent2']).'"';
		    	$result2 = $jakdb->query($sql2);
		    	
		    } elseif ($defaults['jak_catparent']) {
		    
		    	$sqladd = ',catparent = "'.$defaults['jak_catparent'].'",catparent2 = 0';
		    	
		    	// Update categories table so if any sub-sub exist move them with the new sub menu
		    	$sql2 = 'UPDATE '.$jaktable.' SET subexist = 1 WHERE id = "'.smartsql($defaults['jak_catparent']).'"';
		    	$result2 = $jakdb->query($sql2);
		    	
		    } else {
		    
		    
		    }
		    
		    if (!empty($defaults['jak_img'])) {
		    	$catimg = ',catimg = "'.$defaults['jak_img'].'"';
		    } else {
		    	$catimg = '';
		    }
		
			$result = $jakdb->query('INSERT INTO '.$jaktable.' SET 
			name = "'.smartsql($defaults['jak_name']).'",
			name_l2 = "'.smartsql($defaults['jak_name2']).'",
			name_l3 = "'.smartsql($defaults['jak_name3']).'",
			varname = "'.smartsql($defaults['jak_varname']).'",
			exturl = "'.smartsql($defaults['jak_url']).'",
			showmenu = '.$menu.',
			showfooter = '.$footer.$sqladd.$catimg.',
			permission = "'.$permission.'",
			catorder = 2');
			
			$rowid = $jakdb->jak_last_id();
		
			if (!$result) {
		    	jak_redirect(BASE_URL.'index.php?p=categories&sp=newcat&ssp=e');;
			} else {
		        jak_redirect(BASE_URL.'index.php?p=categories&sp=edit&ssp='.$rowid.'&sssp=s');
		    }
		 } else {
		    
		   	$errors['e'] = $tl['error']['e'];
		    $errors = $errors;
		    }
		}
		
		// Get all usergroup's
		$JAK_USERGROUP = jak_get_usergroup_all('usergroup');
		
		// Call the template
		$template = 'newcat.php';
		
	break;
	default:
	
		// Additional DB Information
		$jakfield = 'catparent';
		$jakfield1 = 'varname';
		$jakfield2 = 'catparent2';
 
 	switch ($page1) {
 	case 'delete':

	if (jak_row_exist($page2,$jaktable) && $page2 != 1) {
	
		$sql = 'SELECT catparent, catparent2, pluginid FROM '.$jaktable.' WHERE id = "'.smartsql($page2).'" LIMIT 1';
		$result = $jakdb->query($sql);
		$row = $result->fetch_assoc();
		
		if ($row['pluginid'] == 0) {
		
		// Finally delete the category
		$sql = 'DELETE FROM '.$jaktable.' WHERE id = '.smartsql($page2).'';
		$result = $jakdb->query($sql);
		
		// Now if exist do the dirty work find some others and update the database
		if ($row['catparent2'] > 0) {
			
			// The sql query
			$sql1 = 'SELECT id FROM '.$jaktable.' WHERE catparent2 = "'.smartsql($row['catparent2']).'" LIMIT 1';
			$result1 = $jakdb->query($sql1);
			while ($jakdb->affected_rows == 0) {
			
				// Update categories table so if any sub-sub exist move them with the new sub menu
			    $sql2 = 'UPDATE '.$jaktable.' SET subsubexist = 0 WHERE id = "'.smartsql($row['catparent2']).'"';
			    $result2 = $jakdb->query($sql2);
			    
			}
		
		} else if ($row['catparent'] > 0) {
		
			// The sql query
			$sql1 = 'SELECT id FROM '.$jaktable.' WHERE catparent = "'.smartsql($row['catparent']).'" LIMIT 1';
			$result1 = $jakdb->query($sql1);
			while ($jakdb->affected_rows == 0) {
			
				// Update categories table so if any sub-sub exist move them with the new sub menu
			    $sql2 = 'UPDATE '.$jaktable.' SET subexist = 0 WHERE id = "'.smartsql($row['catparent']).'"';
			    $result2 = $jakdb->query($sql2);
			    
			}
		
		} else {
		
		}
	
		if (!$result) {
	    	jak_redirect(BASE_URL.'index.php?p=categories&sp=e');
		} else {
	        jak_redirect(BASE_URL.'index.php?p=categories&sp=s');
	    }
	    
	} else {
		jak_redirect(BASE_URL.'index.php?p=categories&sp=epc');
	}
	
	} elseif ($page1 == 'delete' && $page2 == 1) {
		jak_redirect(BASE_URL.'index.php?p=categories&sp=ech');
	} else {
		jak_redirect(BASE_URL.'index.php?p=error&sp=ene');
	}
		break;
		case 'edit':
			
			if (jak_row_exist($page2,$jaktable)) {
	
			if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			    $defaults = $_POST;
			
			    if (empty($defaults['jak_name'])) {
			        $errors['e1'] = $tl['error']['e12'];
			    }
			    
			    if (empty($defaults['jak_varname']) || !preg_match('/^([a-z-_0-9]||[-_])+$/', $defaults['jak_varname'])) {
			        $errors['e3'] = $tl['error']['e14'];
			    }
			    
			    if (jak_field_not_exist_id($defaults['jak_varname'],$page2,$jaktable,$jakfield1) || jak_varname_blocked($defaults['jak_varname'])) {
			        $errors['e2'] = $tl['error']['e13'];
			    }
			        
			    if (count($errors) == 0) {
			    
			    if (!isset($defaults['jak_permission'])) {
			    	$permission = 0;
			    } else {
			    	$permission = join(',', $defaults['jak_permission']);
			    }
			    
			    if ($defaults['jak_catparent2']) {
			    
			    	$sqls = 'SELECT catparent FROM '.$jaktable.' WHERE id = "'.$defaults['jak_catparent2'].'"';
			    	$results = $jakdb->query($sqls);
			    	$rows = $results->fetch_assoc();
			    	
			    	$sqladd = 'catparent = "'.$rows['catparent'].'", catparent2 = "'.$defaults['jak_catparent2'].'",';
			    	
			    } else if ($defaults['jak_catparent'] != $defaults['jak_catparent_old']) {
			    
			    	if ($defaults['jak_subsubexist']) {
			    	
			    		$jakdb->query('UPDATE '.$jaktable.' SET catparent = "'.smartsql($page2).'", catparent2 = 0 WHERE catparent2 = "'.smartsql($page2).'"');
			    	
				    	if ($defaults['jak_catparent'] != 0) { 
				    		$jakdb->query('UPDATE '.$jaktable.' SET subexist = 1 WHERE id = "'.$defaults['jak_catparent'].'"');
				    	}
				    	
				    	if (jak_field_not_exist($defaults['jak_catparent_old'], $jaktable, 'catparent')) {
				    	
				    		$jakdb->query('UPDATE '.$jaktable.' SET subexist = 0 WHERE id = "'.$defaults['jak_catparent_old'].'"');
				    	}
				    	
				    	$include = 'subexist = 1, subsubexist = 0,';
				    	
				    } else if ($defaults['jak_subexist']) {
				    
				    	$jakdb->query('UPDATE '.$jaktable.' SET catparent = "'.$defaults['jak_catparent'].'", catparent2 = "'.smartsql($page2).'" WHERE catparent = "'.smartsql($page2).'"');
				    	
				    		if ($defaults['jak_catparent'] != 0) { 
				    			$jakdb->query('UPDATE '.$jaktable.' SET subexist = 1 WHERE id = "'.$defaults['jak_catparent'].'"');
				    		}
				    		
				    		if (jak_field_not_exist($defaults['jak_catparent_old'], $jaktable, 'catparent')) {
				    		
				    			$jakdb->query('UPDATE '.$jaktable.' SET subexist = 0 WHERE id = "'.$defaults['jak_catparent_old'].'"');
				    		}
				    		
				    		$include = 'subexist = 0, subsubexist = 1,';
				    
				    
				    } else {
				    
				    	if ($defaults['jak_catparent'] != 0) { 
				    		$jakdb->query('UPDATE '.$jaktable.' SET subexist = 1 WHERE id = "'.$defaults['jak_catparent'].'"');
				    	}
				    	
				    	if (jak_field_not_exist($defaults['jak_catparent_old'], $jaktable, 'catparent')) {
				    	
				    		$jakdb->query('UPDATE '.$jaktable.' SET subexist = 0 WHERE id = "'.$defaults['jak_catparent_old'].'"');
				    	}
				    }
			    		    
			    	$include .= 'catparent = "'.$defaults['jak_catparent'].'", catparent2 = 0,';
			    
			    } else {
			    
			    	// Well nothing to do...
			    }
			    
			    
			    if (!empty($defaults['jak_img'])) {
			    	$include .= 'catimg = "'.$defaults['jak_img'].'",';
			    } else {
			    	$include .= 'catimg = NULL,';
			    }
			
				$result = $jakdb->query('UPDATE '.$jaktable.' SET 
				name = "'.smartsql($defaults['jak_name']).'",
				name_l2 = "'.smartsql($defaults['jak_name2']).'",
				name_l3 = "'.smartsql($defaults['jak_name3']).'",
				varname = "'.smartsql($defaults['jak_varname']).'",
				exturl = "'.smartsql($defaults['jak_url']).'",
				showmenu = "'.$defaults['jak_menu'].'",
				showfooter = "'.$defaults['jak_footer'].'",
				'.$include.'
				permission = "'.$permission.'"
				WHERE id = "'.smartsql($page2).'"');
			
				if (!$result) {
			    	jak_redirect(BASE_URL.'index.php?p=categories&sp=edit&ssp='.$page2.'&sssp=e');
				} else {
					
					// Now let us delete the all the cache file
					$cacheallfiles = '../'.JAK_CACHE_DIRECTORY.'/';
					$msfi = glob($cacheallfiles."*.php");
					if ($msfi) foreach ($msfi as $filen) {
					    if (file_exists($filen)) unlink($filen);
					}
					
			        jak_redirect(BASE_URL.'index.php?p=categories&sp=edit&ssp='.$page2.'&sssp=s');
			    }
			 } else {
			   	$errors['e'] = $tl['error']['e'];
			    $errors = $errors;
			 }
	}
	
	// Get the data
	$JAK_FORM_DATA = jak_get_data($page2,$jaktable);
	
	// Get all usergroup's
	$JAK_USERGROUP = jak_get_usergroup_all('usergroup');
	
	
	$template = 'editcat.php';
	
	} else {
	   	jak_redirect(BASE_URL.'index.php?p=error&sp=cat-not-exist');
	}
	
	break;
	default:
		// Call the template
		$template = 'categories.php';
	}
}
?>