<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

// prevent direct php access
define('JAK_ADMIN_PREVENT_ACCESS', 1);

if (!file_exists('config.php')) die('[index.php] config.php not found');
require_once 'config.php';

$page = ($temppa ? filter_var($temppa, FILTER_SANITIZE_STRING) : '');
$page1 = ($temppa1 ? filter_var($temppa1, FILTER_SANITIZE_STRING) : '');
$page2 = ($temppa2 ? filter_var($temppa2, FILTER_SANITIZE_STRING) : '');
$page3 = ($temppa3 ? filter_var($temppa3, FILTER_SANITIZE_STRING) : '');
$page4 = ($temppa4 ? filter_var($temppa4, FILTER_SANITIZE_STRING) : '');
$page5 = ($temppa5 ? filter_var($temppa5, FILTER_SANITIZE_STRING) : '');
$page6 = ($temppa5 ? filter_var($temppa6, FILTER_SANITIZE_STRING) : '');

// Only the SuperAdmin in the config file see everything
if ($jakuser->jakSuperadminaccess(JAK_USERID_CMS)) {
	$JAK_SPECIALACCESS = true;
	$JAK_UNDELETABLE = true;
	define('JAK_SUPERADMINACCESS', true);
	define('JAK_ADMINACCESS', true);
} else {
	define('JAK_SUPERADMINACCESS', false);
}

// Only the Admin's in the config can have access
if ($jakuser->jakAdminaccess(JAK_USERID_CMS)) {
	define('JAK_ADMINACCESS', true);
$_SESSION['JAKLoggedInAdmin'] = true;
} else {
	define('JAK_ADMINACCESS', false);
}

// All other user will be redirect to the homepage, nothing else to do for this people
if (JAK_USERID_CMS && !JAK_ADMINACCESS) jak_redirect(BASE_URL_ORIG);

if (file_exists(APP_PATH.'admin/lang/'.JAK_LANG.'.ini')) {
    $tl = parse_ini_file(APP_PATH.'admin/lang/'.JAK_LANG.'.ini', true);
} else {
    trigger_error('Translation file not found');
}

// We need the template folder, title, author and lang as template variable
$JAK_CONTACT_FORM = JAK_CONTACTFORM;
$JAK_REGISTER_FORM = JAK_REGISTER;
define('JAK_PAGINATE_ADMIN', 1);

// First check if the user is logged in
if (JAK_USERID_CMS) {

// Get all the Plugins
$jakplugins = new JAK_plugins(2, '');

// Get all the Hooks
$jakhooks = new JAK_hooks(1, '');

// First load the language from the hook
$hookadminlang = $jakhooks->jakGethook("php_admin_lang");
if ($hookadminlang) { foreach($hookadminlang as $halang)
{
	eval($halang['phpcode']);
}
}

// Get the admin head hook for implementing css or other stuff belongs into the head section
$JAK_HOOK_HEAD_ADMIN = $jakhooks->jakGethook("tpl_admin_head");
$JAK_HOOK_FOOTER_ADMIN = $jakhooks->jakGethook("tpl_admin_footer");

// Get all plugins out the databse
$JAK_PLUGINS = $jakplugins->jakGetarray();
$JAK_PLUGINS_TOPNAV = $jakplugins->jakAdmintopnav();
$JAK_PLUGINS_MANAGENAV = $jakplugins->jakAdminmanagenav();
// We need the tags if active right in the beginning
define('JAK_TAGS', $jakplugins->getPHPcodeid(3, "active"));

// Show links in template only the user have access
$JAK_MODULES = $jakuser->jakModuleaccess(JAK_USERID_CMS, JAK_ACCESSGENERAL);
$JAK_MODULEM = $jakuser->jakModuleaccess(JAK_USERID_CMS, JAK_ACCESSMANAGE);

// Get the name from the user for the welcome message
$JAK_WELCOME_NAME = $jakuser->getVar("name");
}

// Now get the forgot password link into the right shape
$P_FORGOT_PASS_ADMIN = JAK_rewrite::jakParseurl($tl['login']['l12'], '', '', '', '');

// We do not need code highlighting
$CODE_HIGHLIGHT = false;

// Set page to zero, first.
$checkp = 0;

// Define http referrer
if (!isset($_SERVER['HTTP_REFERER'])) $_SERVER['HTTP_REFERER'] = '';

// Now run the php code from the plugin section only when we logged in
if (JAK_USERID_CMS) {

// Run the hook admin index top for sidebar widgets
// Admin index hook
$hookadminit = $jakhooks->jakGethook("php_admin_index_top");
if ($hookadminit)
foreach($hookadminit as $hait)
{
	eval($hait['phpcode']);
}

$pluginadminphp = $jakplugins->jakAdminindex();
if ($pluginadminphp) { foreach($pluginadminphp as $pl) {
	// Page name upper case
	$plname = strtoupper($pl['name']);
	
	// define the plugin id first
	define('JAK_PLUGIN_'.$plname, $pl['id']);
	
	// Get the access out into define
	define('JAK_ACCESS'.$plname, $pl['access']);
		
	// Write the template code for further access
	$JAK_.$plname = true;
		
	// then load the php code
	eval($pl['phpcode']);
}
}
}

// home
    if ($page == '') {
        #show login page only if the admin is not logged in
        #else show homepage
        if (!JAK_USERID_CMS) {
            require_once 'login.php';
        } else {
        	require_once 'include/serverconfig.php';
        	$JAK_SETTING = jak_get_setting('version');
        	$JAK_PROVED = 1;
        	$JAK_PAGE_ACTIVE = 1;
            $html_title = $tl['login']['l'];
            
            // define file better for caching
            $cacheverfile = APP_PATH.JAK_CACHE_DIRECTORY.'/version.php';
   			$admincacheexist = false;
            
            if (file_exists($cacheverfile)) {
             	
             	// Now include the created definefile
             	include_once $cacheverfile;
             	
             	$admincacheexist = true;
             	
             	$admin_cache_expire = JAK_ADMIN_CACHE_CREATED + 86400;
             	
             	if ($admin_cache_expire < time()) {
             	
             		if (file_exists($cacheverfile)) {
             			unlink($cacheverfile);
             			$admincacheexist = false;
             		}
             	
             	}
             	
            }
            
            
            
        	// Admin index hook
        	$hookadmini = $jakhooks->jakGethook("php_admin_index");
        	if ($hookadmini)
        	foreach($hookadmini as $hai)
        	{
        		eval($hai['phpcode']);
        	}
        	// Admin index template
        	$JAK_HOOK_ADMIN_INDEX = $jakhooks->jakGethook("tpl_admin_index");
        	
        	// Get the to-do list
        	require "../class/class.todo.php";
        	// Select all the todos, ordered by position:
        	$todo = $jakdb->query('SELECT * FROM '.DB_PREFIX.'todo_list ORDER BY `position` ASC');
        	
        	// to-do is an array and get the while
        	$todos = array();
        	while ($rowtd = $todo->fetch_assoc()) {
        		$todos[] = new JAK_ToDo($rowtd);
        	}
        	
        	// Get the stats
        	// Get the page hits
        	$result = $jakdb->query('SELECT title, hits FROM '.DB_PREFIX.'pages ORDER BY hits DESC LIMIT 10');
        	
        	// Iterate through the rows
        	while ($row = $result->fetch_assoc()) {	
        		
        		$pageCdata[] = "['".$row['title']."', ".$row['hits']."]";
        	}
        	
        	if ($pageCdata) $pageCdata = join(", ", $pageCdata);
        	
        	// Get the total page hits
        	$pct = $jakdb->query('SELECT COUNT(id) as total FROM '.DB_PREFIX.'pages');
        	$rpct = $pct->fetch_assoc();
        	$pageCtotal = $rpct['total'];
        	
        	// Get the total user
        	$uct = $jakdb->query('SELECT COUNT(id) as total FROM '.DB_PREFIX.'user');
        	$ruct = $uct->fetch_assoc();
        	$userCtotal = $ruct['total'];
        	
        	// Get the total tags
        	$tct = $jakdb->query('SELECT COUNT(id) as total FROM '.DB_PREFIX.'tags');
        	$rtct = $tct->fetch_assoc();
        	$tagsCtotal = $rtct['total'];
        	
        	// Get the total plugins
        	$plct = $jakdb->query('SELECT COUNT(id) as total FROM '.DB_PREFIX.'plugins');
        	$rplct = $plct->fetch_assoc();
        	$pluginCtotal = $rplct['total'];
        	
        	// Get the total hooks
        	$hct = $jakdb->query('SELECT COUNT(id) as total FROM '.DB_PREFIX.'pluginhooks');
        	$rhct = $hct->fetch_assoc();
        	$hookCtotal = $rhct['total'];
        	
        	// include the template
        	$template = 'index.php';
        }
        $checkp = 1;
       	}
   if ($page == 'logout') {
        $checkp = 1;
        if (!JAK_USERID_CMS) {
            jak_redirect(BASE_URL);
        }
        if (JAK_USERID_CMS) {
            $jakuserlogin->jakLogout(JAK_USERID_CMS);
            jak_redirect(BASE_URL);
        }
    }
    if ($page == '404') {
        if (!JAK_USERID_CMS) {
            jak_redirect(BASE_URL);
        }
        // Go to the 404 Page
        $JAK_PROVED = 1;
        $html_title = '404 / ' . JAK_TITLE;
        $template = '404.php';
        $checkp = 1;
    }
    if ($page == 'site') {
        require_once 'site.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }
    if ($page == 'logs') {
        require_once 'logs.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }
    if ($page == 'searchlog') {
        require_once 'searchlog.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }
    if ($page == 'setting') {
        require_once 'setting.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }
    if ($page == 'hvm') {
        require_once 'hvm.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }  
    if ($page == 'user') {
        require_once 'user.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }
    if ($page == 'categories') {
        require_once 'categories.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE1 = 1;
        $checkp = 1;
    }     
    if ($page == 'page') {
        require_once 'page.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE1 = 1;
        $checkp = 1;
    }
    if ($page == 'contactform') {
        require_once 'contactform.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE1 = 1;
        $checkp = 1;
    }
    if ($page == 'plugins') {
        require_once 'plugins.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }
    if ($page == 'template') {
        require_once 'template.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }
    if ($page == 'usergroup') {
        require_once 'usergroup.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }
    if ($page == 'maintenance') {
        require_once 'maintenance.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }
    if ($page == 'version-control') {
        require_once 'vcontrol.php';
        $JAK_PROVED = 1;
        $JAK_PAGE_ACTIVE = 1;
        $checkp = 1;
    }
     
// if page not found
if ($checkp == 0) jak_redirect(BASE_URL.'index.php?p=404');

if (isset($template) && $template != '') {
	include_once APP_PATH.'admin/template/'.$template;
}

// Get the plugin template
if (isset($plugin_template) && $plugin_template != '') {
	
	include_once APP_PATH.$plugin_template;
}
    
// Finally close all db connections
$jakdb->jak_close();
?>