/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

$(document).ready(function() {

$('#jakEditor, #jakEditorLight').jakcmsE(jakHTMLeditor);
$('#jakEditor2, #jakEditorLight2').jakcmsE(jakHTMLeditor2);
$('#jakEditor3, #jakEditorLight3').jakcmsE(jakHTMLeditor3);

$(".cell").hover(
  function () {
    $(this).append($("<span> ***</span>"));
  }, 
  function () {
    $(this).find("span:last").remove();
  }
);

});

jakHTMLeditor = {
	nameSpace:       "html", // Useful to prevent multi-instances CSS conflict
	onShiftEnter:	{keepDefault:false, replaceWith:'<br />\n'},
	onCtrlEnter:	{keepDefault:false, openWith:'\n<p>', closeWith:'</p>\n'},
	onTab:			{keepDefault:false, openWith:'	 '},
	markupSet: [
		{name:'Save', className:'save', beforeInsert:function(jakcmsE) { miu.save(jakcmsE) } },
		{name:'Load', className:'load', beforeInsert:function(jakcmsE) { miu.load(jakcmsE) } },
		{separator:'---------------' },
	{name:'Headings', className:'headings', dropMenu: [
		{name:'Heading 1', key:'1', openWith:'<h1(!( class="[![Class]!]")!)>', closeWith:'</h1>', placeHolder:'Your title here...', className:'h1' },
		{name:'Heading 2', key:'2', openWith:'<h2(!( class="[![Class]!]")!)>', closeWith:'</h2>', placeHolder:'Your title here...', className:'h2' },
		{name:'Heading 3', key:'3', openWith:'<h3(!( class="[![Class]!]")!)>', closeWith:'</h3>', placeHolder:'Your title here...', className:'h3' },
		{name:'Heading 4', key:'4', openWith:'<h4(!( class="[![Class]!]")!)>', closeWith:'</h4>', placeHolder:'Your title here...', className:'h4' },
		{name:'Heading 5', key:'5', openWith:'<h5(!( class="[![Class]!]")!)>', closeWith:'</h5>', placeHolder:'Your title here...', className:'h5' },
		{name:'Heading 6', key:'6', openWith:'<h6(!( class="[![Class]!]")!)>', closeWith:'</h6>', placeHolder:'Your title here...', className:'h6' }
	] },
	{name:'Fonts', className:'font', dropMenu: [
	    { name:'Arial', openWith:'(!(<span class="farial">|!| class="farial")!)', closeWith:'(!(</span>|!|)!)', className:"font-1" },
	    { name:'Helvetica', openWith:'(!(<span class="fhelvetica">|!| class="fhelvetica")!)', closeWith:'(!(</span>|!|)!)', className:"font-2" },
	    { name:'Times New Roman', openWith:'(!(<span class="ftimes">|!| class="ftimes")!)', closeWith:'(!(</span>|!|)!)', className:"font-3" },
	    { name:'Trebuchet MS', openWith:'(!(<span class="ftrebuchet">|!| class="ftrebuchet")!)', closeWith:'(!(</span>|!|)!)', className:"font-4" },
	    { name:'Verdana', openWith:'(!(<span class="fverdana">|!| class="fverdana")!)', closeWith:'(!(</span>|!|)!)', className:"font-5" },
	] },
	{name:'Paragraph', openWith:'<p(!( class="[![Class]!]")!)>', closeWith:'</p>' },
	{separator:'---------------' },
	{name:'Bold', key:'B', openWith:'(!(<strong>|!|<b>)!)', closeWith:'(!(</strong>|!|</b>)!)' },
	{name:'Italic', key:'I', openWith:'(!(<em>|!|<i>)!)', closeWith:'(!(</em>|!|</i>)!)' },
	{name:'Stroke through', key:'S', openWith:'<del>', closeWith:'</del>' },
	{separator:'---------------' },
	{name:'Alignments', className:'alignments', dropMenu:[
		{name:'Left', openWith:'(!(<p class="ftleft">|!| class="ftleft")!)', closeWith:'(!(</p>|!|)!)', className:'left' },
		{name:'Center', openWith:'(!(<p class="ftcenter">|!| class="ftcenter")!)', closeWith:'(!(</p>|!|)!)', className:'center' },
		{name:'Right', openWith:'(!(<p class="ftright;">|!| class="ftright;")!)', closeWith:'(!(</p>|!|)!)', className:'right' },
		{name:'Justify', openWith:'(!(<p class="ftjustify">|!| class="ftjustify")!)', closeWith:'(!(</p>|!|)!)', className:'justify' }
		]
	},
	{separator:'---------------' },
	{name:'Ul', openWith:'<ul>\n<li>', closeWith:'</li>\n</ul>\n' },
	{name:'Ol', openWith:'<ol>\n<li>', closeWith:'</li>\n</ol>\n' },
	{name:'Li', openWith:'<li>', closeWith:'</li>' },
	{separator:'---------------' },
	{name:'Smiley', className:'smilies', dropMenu:[
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-cool.png" alt="smiley-cool" />', className:'s-1' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-cry.png" alt="smiley-cry" />', className:'s-2' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-frown.png" alt="smiley-frown" />', className:'s-3' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-kiss.png" alt="smiley-kiss" />', className:'s-4' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-laughing.png" alt="smiley-laughing" />', className:'s-5' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-mouth.png" alt="smiley-mouth" />', className:'s-6' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-sealed.png" alt="smiley-sealed" />', className:'s-7' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-shout.png" alt="smiley-shout" />', className:'s-8' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-smile.png" alt="smiley-smile" />', className:'s-9' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-tongue.png" alt="smiley-tongue" />', className:'s-10' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-undecided.png" alt="smiley-undecided" />', className:'s-11' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-unhappy.png" alt="smiley-unhappy" />', className:'s-12' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-weird.png" alt="smiley-weird" />', className:'s-13' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-what.png" alt="smiley-what" />', className:'s-14' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-wink.png" alt="smiley-wink" />', className:'s-15' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-yell.png" alt="smiley-yell" />', className:'s-16' }
	] },
	{name:'Colors', className:'palette', dropMenu: [
			{name:'Yellow',	openWith:'(!(<span style="color:#FCE94F">|!| style="color:#FCE94F")!)', closeWith:'(!(</span>|!|)!)', className:"col1-1" },
			{name:'Yellow',	openWith:'(!(<span style="color:#EDD400">|!| style="color:#EDD400")!)', closeWith:'(!(</span>|!|)!)', className:"col1-2" },
			{name:'Yellow', openWith:'(!(<span style="color:#C4A000">|!| style="color:#C4A000")!)', closeWith:'(!(</span>|!|)!)', className:"col1-3" },
						
			{name:'Orange', openWith:'(!(<span style="color:#FCAF3E">|!| style="color:#FCAF3E")!)', closeWith:'(!(</span>|!|)!)', className:"col2-1" },
			{name:'Orange', openWith:'(!(<span style="color:#F57900">|!| style="color:#F57900")!)', closeWith:'(!(</span>|!|)!)', className:"col2-2" },
			{name:'Orange', openWith:'(!(<span style="color:#CE5C00">|!| style="color:#CE5C00")!)', closeWith:'(!(</span>|!|)!)', className:"col2-3" },
						
			{name:'Brown', 	openWith:'(!(<span style="color:#E9B96E">|!| style="color:#E9B96E")!)', closeWith:'(!(</span>|!|)!)', className:"col3-1" },
			{name:'Brown', 	openWith:'(!(<span style="color:#C17D11">|!| style="color:#C17D11")!)', closeWith:'(!(</span>|!|)!)', className:"col3-2" },
			{name:'Brown',	openWith:'(!(<span style="color:#8F5902">|!| style="color:#8F5902")!)', closeWith:'(!(</span>|!|)!)', className:"col3-3" },
						
			{name:'Green', 	openWith:'(!(<span style="color:#8ae234">|!| style="color:#8Ae234")!)', closeWith:'(!(</span>|!|)!)', className:"col4-1" },
			{name:'Green', 	openWith:'(!(<span style="color:#73d216">|!| style="color:#73d216")!)', closeWith:'(!(</span>|!|)!)', className:"col4-2" },
			{name:'Green',	openWith:'(!(<span style="color:#4e9a06">|!| style="color:#4e9aA06")!)', closeWith:'(!(</span>|!|)!)', className:"col4-3" },
						
			{name:'Blue', 	openWith:'(!(<span style="color:#729fcf">|!| style="color:#729fcf")!)', closeWith:'(!(</span>|!|)!)', className:"col5-1" },
			{name:'Blue', 	openWith:'(!(<span style="color:#3465a4">|!| style="color:#3465a4")!)', closeWith:'(!(</span>|!|)!)', className:"col5-2" },
			{name:'Blue',	openWith:'(!(<span style="color:#204a87">|!| style="color:#204a87")!)', closeWith:'(!(</span>|!|)!)', className:"col5-3" },
	
			{name:'Purple', openWith:'(!(<span style="color:#ad7fa8">|!| style="color:#ad7fa8")!)', closeWith:'(!(</span>|!|)!)', className:"col6-1" },
			{name:'Purple', openWith:'(!(<span style="color:#75507b">|!| style="color:#75507b")!)', closeWith:'(!(</span>|!|)!)', className:"col6-2" },
			{name:'Purple',	openWith:'(!(<span style="color:#5c3566">|!| style="color:#5c3566")!)', closeWith:'(!(</span>|!|)!)', className:"col6-3" },
						
			{name:'Red', openWith:'(!(<span style="color:#ef2929">|!| style="color:#ef2929")!)', closeWith:'(!(</span>|!|)!)', className:"col7-1" },
			{name:'Red', openWith:'(!(<span style="color:#cc0000">|!| style="color:#cc0000")!)', closeWith:'(!(</span>|!|)!)', className:"col7-2" },
			{name:'Red', openWith:'(!(<span style="color:#a40000">|!| style="color:#a40000")!)', closeWith:'(!(</span>|!|)!)', className:"col7-3" },
						
			{name:'Gray', openWith:'(!(<span style="color:#fff">|!| style="color:#fff")!)', closeWith:'(!(</span>|!|)!)', className:"col8-1" },
			{name:'Gray', openWith:'(!(<span style="color:#D3D7CF">|!| style="color:#D3D7CF")!)', closeWith:'(!(</span>|!|)!)', className:"col8-2" },
			{name:'Gray', openWith:'(!(<span style="color:#BABDB6">|!| style="color:#BABDB6")!)', closeWith:'(!(</span>|!|)!)', className:"col8-3" },
						
			{name:'Gray', openWith:'(!(<span style="color:#888A85">|!| style="color:#888A85")!)', closeWith:'(!(</span>|!|)!)', className:"col9-1" },
			{name:'Gray', openWith:'(!(<span style="color:#555753">|!| style="color:#555753")!)', closeWith:'(!(</span>|!|)!)', className:"col9-2" },
			{name:'Gray', openWith:'(!(<span style="color:#000000">|!| style="color:#000000")!)', closeWith:'(!(</span>|!|)!)', className:"col9-3" },
			
			{name:'JAKColor', openWith:'(!(<span style="color:#db6c27">|!| style="color:#db6c27")!)', closeWith:'(!(</span>|!|)!)', className:"col10-1" },
			{name:'JAKColor', openWith:'(!(<span style="color:#df1f26">|!| style="color:#df1f26")!)', closeWith:'(!(</span>|!|)!)', className:"col10-2" },
			{name:'JAKColor', openWith:'(!(<span style="color:#70aa42">|!| style="color:#70aa42")!)', closeWith:'(!(</span>|!|)!)', className:"col10-3" }
		] },
		
		{name:'Picture', key:'P', replaceWith:'<img src="[![Source:!:http://]!]" alt="[![Alternative text]!]" />' },
		{name:'Link', key:'L', openWith:'<a href="[![Link:!:http://]!]"(!( title="[![Title]!]")!)>', closeWith:'</a>', placeHolder:'Your text to link...' },
		{name:'iManager', beforeInsert:function() {
		    $.colorbox({
		    	href: "../../js/teditor/plugins/filemanager/dialog.php?type=1&editor=mce_0&lang=eng&fldr=&field_id=jakEditor&editor=1",
		    	iframe: true,
		    	width: 800,
		    	height: 630
		    });
		  } },
		{name:'fManager', beforeInsert:function() {
		    $.colorbox({
		    	href: "../../js/teditor/plugins/filemanager/dialog.php?type=2&editor=mce_0&lang=eng&fldr=&field_id=jakEditor&editor=1",
		    	iframe: true,
		    	width: 800,
		    	height: 630
		    });
		  } },
		{separator:'---------------' },
		{name:'Row Fluid', className:'fluid', openWith:'<div class="row-fluid">', closeWith:'</div>', placeHolder:'Your Grid inside here...' },
		{name:'Grid', className:'grid', dropMenu: [
			{name:'Grid 1', openWith:'<div class="span1">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 2', openWith:'<div class="span2">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 3', openWith:'<div class="span3">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 4 (1/3)', openWith:'<div class="span4">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 5', openWith:'<div class="span5">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 6 (1/2)', openWith:'<div class="span6">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 7', openWith:'<div class="span7">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 8 (2/3)', openWith:'<div class="span8">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 9', openWith:'<div class="span9">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 10', openWith:'<div class="span10">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 11', openWith:'<div class="span11">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 12', openWith:'<div class="span12">', closeWith:'</div>', placeHolder:'Your content here...' }
		] },
		{name:'Offset', className:'offset', dropMenu: [
			{name:'Offset 1', replaceWith:'class="offset1"' },
			{name:'Offset 2', replaceWith:'class="offset2"' },
			{name:'Offset 3', replaceWith:'class="offset3"' },
			{name:'Offset 4', replaceWith:'class="offset4"' },
			{name:'Offset 5', replaceWith:'class="offset5"' },
			{name:'Offset 6', replaceWith:'class="offset6"' },
			{name:'Offset 7', replaceWith:'class="offset7"' },
			{name:'Offset 8', replaceWith:'class="offset8"' },
			{name:'Offset 9', replaceWith:'class="offset9"' },
			{name:'Offset 10', replaceWith:'class="offset10"' },
			{name:'Offset 11', replaceWith:'class="offset11"' },
			{name:'Offset 12', replaceWith:'class="offset12"' }
		] },
		{name:'Add CSS', className:'css', dropMenu: [
			{name:'Hero Head', openWith:'<div class="hero-unit">', closeWith:'</div>', placeHolder:'Your content here…' },
			{name:'Well, well...', openWith:'<div class="well">', closeWith:'</div>', placeHolder:'Your content here…' },
			{name:'Thumbnails', replaceWith:'<ul class="thumbnails"><li class="span4"><div class="thumbnail">Your Image goes here...<div class="caption"><h3>Thumbnail label</h3><p>Thumbnail caption...</p></div></div></li></ul>' },
			{name:'Circle Image', replaceWith:'class="img-circle"' },
			{name:'Rounded Image', replaceWith:'class="img-rounded"' },
			{name:'Polaroid Image', replaceWith:'class="img-polaroid"' },
			{name:'LightBox', replaceWith:'class="lightbox"' },
			{name:'Progress Bar', replaceWith:'<div class="progress progress-striped active"><div class="bar" style="width: 40%;"></div></div>' },
			{name:'Label', openWith:'<span class="label">', closeWith:'</span>', placeHolder:'Your content here…' },
			{name:'Badges', openWith:'<span class="badge">', closeWith:'</span>', placeHolder:'Your content here…' },
			{name:'Success', openWith:'<div class="alert alert-success alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Info', openWith:'<div class="alert alert-info alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Alert', openWith:'<div class="alert alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Error', openWith:'<div class="alert alert-error alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Code', replaceWith:'<pre><code>[![Source:!:Your text here...]!]</code></pre>' }
		] },
		{separator:'---------------' },
		{name:'Clean', className:'clean', replaceWith:function(jakcmsE) { return jakcmsE.selection.replace(/<(.*?)>/g, "") } },
		{name:'Preview', className:'preview', call:'preview' }
		]
}

jakHTMLeditor2 = {
	nameSpace:       "html", // Useful to prevent multi-instances CSS conflict
	onShiftEnter:	{keepDefault:false, replaceWith:'<br />\n'},
	onCtrlEnter:	{keepDefault:false, openWith:'\n<p>', closeWith:'</p>\n'},
	onTab:			{keepDefault:false, openWith:'	 '},
	markupSet: [
		{name:'Save', className:'save', beforeInsert:function(jakcmsE) { miu.save(jakcmsE) } },
		{name:'Load', className:'load', beforeInsert:function(jakcmsE) { miu.load(jakcmsE) } },
		{separator:'---------------' },
	{name:'Headings', className:'headings', dropMenu: [
		{name:'Heading 1', key:'1', openWith:'<h1(!( class="[![Class]!]")!)>', closeWith:'</h1>', placeHolder:'Your title here...', className:'h1' },
		{name:'Heading 2', key:'2', openWith:'<h2(!( class="[![Class]!]")!)>', closeWith:'</h2>', placeHolder:'Your title here...', className:'h2' },
		{name:'Heading 3', key:'3', openWith:'<h3(!( class="[![Class]!]")!)>', closeWith:'</h3>', placeHolder:'Your title here...', className:'h3' },
		{name:'Heading 4', key:'4', openWith:'<h4(!( class="[![Class]!]")!)>', closeWith:'</h4>', placeHolder:'Your title here...', className:'h4' },
		{name:'Heading 5', key:'5', openWith:'<h5(!( class="[![Class]!]")!)>', closeWith:'</h5>', placeHolder:'Your title here...', className:'h5' },
		{name:'Heading 6', key:'6', openWith:'<h6(!( class="[![Class]!]")!)>', closeWith:'</h6>', placeHolder:'Your title here...', className:'h6' }
	] },
	{name:'Fonts', className:'font', dropMenu: [
	    { name:'Arial', openWith:'(!(<span class="farial">|!| class="farial")!)', closeWith:'(!(</span>|!|)!)', className:"font-1" },
	    { name:'Helvetica', openWith:'(!(<span class="fhelvetica">|!| class="fhelvetica")!)', closeWith:'(!(</span>|!|)!)', className:"font-2" },
	    { name:'Times New Roman', openWith:'(!(<span class="ftimes">|!| class="ftimes")!)', closeWith:'(!(</span>|!|)!)', className:"font-3" },
	    { name:'Trebuchet MS', openWith:'(!(<span class="ftrebuchet">|!| class="ftrebuchet")!)', closeWith:'(!(</span>|!|)!)', className:"font-4" },
	    { name:'Verdana', openWith:'(!(<span class="fverdana">|!| class="fverdana")!)', closeWith:'(!(</span>|!|)!)', className:"font-5" },
	] },
	{name:'Paragraph', openWith:'<p(!( class="[![Class]!]")!)>', closeWith:'</p>' },
	{separator:'---------------' },
	{name:'Bold', key:'B', openWith:'(!(<strong>|!|<b>)!)', closeWith:'(!(</strong>|!|</b>)!)' },
	{name:'Italic', key:'I', openWith:'(!(<em>|!|<i>)!)', closeWith:'(!(</em>|!|</i>)!)' },
	{name:'Stroke through', key:'S', openWith:'<del>', closeWith:'</del>' },
	{separator:'---------------' },
	{name:'Alignments', className:'alignments', dropMenu:[
		{name:'Left', openWith:'(!(<p class="ftleft">|!| class="ftleft")!)', closeWith:'(!(</p>|!|)!)', className:'left' },
		{name:'Center', openWith:'(!(<p class="ftcenter">|!| class="ftcenter")!)', closeWith:'(!(</p>|!|)!)', className:'center' },
		{name:'Right', openWith:'(!(<p class="ftright;">|!| class="ftright;")!)', closeWith:'(!(</p>|!|)!)', className:'right' },
		{name:'Justify', openWith:'(!(<p class="ftjustify">|!| class="ftjustify")!)', closeWith:'(!(</p>|!|)!)', className:'justify' }
		]
	},
	{separator:'---------------' },
	{name:'Ul', openWith:'<ul>\n<li>', closeWith:'</li>\n</ul>\n' },
	{name:'Ol', openWith:'<ol>\n<li>', closeWith:'</li>\n</ol>\n' },
	{name:'Li', openWith:'<li>', closeWith:'</li>' },
	{separator:'---------------' },
	{name:'Smiley', className:'smilies', dropMenu:[
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-cool.png" alt="smiley-cool" />', className:'s-1' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-cry.png" alt="smiley-cry" />', className:'s-2' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-frown.png" alt="smiley-frown" />', className:'s-3' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-kiss.png" alt="smiley-kiss" />', className:'s-4' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-laughing.png" alt="smiley-laughing" />', className:'s-5' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-mouth.png" alt="smiley-mouth" />', className:'s-6' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-sealed.png" alt="smiley-sealed" />', className:'s-7' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-shout.png" alt="smiley-shout" />', className:'s-8' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-smile.png" alt="smiley-smile" />', className:'s-9' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-tongue.png" alt="smiley-tongue" />', className:'s-10' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-undecided.png" alt="smiley-undecided" />', className:'s-11' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-unhappy.png" alt="smiley-unhappy" />', className:'s-12' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-weird.png" alt="smiley-weird" />', className:'s-13' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-what.png" alt="smiley-what" />', className:'s-14' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-wink.png" alt="smiley-wink" />', className:'s-15' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-yell.png" alt="smiley-yell" />', className:'s-16' }
	] },
	{name:'Colors', className:'palette', dropMenu: [
			{name:'Yellow',	openWith:'(!(<span style="color:#FCE94F">|!| style="color:#FCE94F")!)', closeWith:'(!(</span>|!|)!)', className:"col1-1" },
			{name:'Yellow',	openWith:'(!(<span style="color:#EDD400">|!| style="color:#EDD400")!)', closeWith:'(!(</span>|!|)!)', className:"col1-2" },
			{name:'Yellow', openWith:'(!(<span style="color:#C4A000">|!| style="color:#C4A000")!)', closeWith:'(!(</span>|!|)!)', className:"col1-3" },
						
			{name:'Orange', openWith:'(!(<span style="color:#FCAF3E">|!| style="color:#FCAF3E")!)', closeWith:'(!(</span>|!|)!)', className:"col2-1" },
			{name:'Orange', openWith:'(!(<span style="color:#F57900">|!| style="color:#F57900")!)', closeWith:'(!(</span>|!|)!)', className:"col2-2" },
			{name:'Orange', openWith:'(!(<span style="color:#CE5C00">|!| style="color:#CE5C00")!)', closeWith:'(!(</span>|!|)!)', className:"col2-3" },
						
			{name:'Brown', 	openWith:'(!(<span style="color:#E9B96E">|!| style="color:#E9B96E")!)', closeWith:'(!(</span>|!|)!)', className:"col3-1" },
			{name:'Brown', 	openWith:'(!(<span style="color:#C17D11">|!| style="color:#C17D11")!)', closeWith:'(!(</span>|!|)!)', className:"col3-2" },
			{name:'Brown',	openWith:'(!(<span style="color:#8F5902">|!| style="color:#8F5902")!)', closeWith:'(!(</span>|!|)!)', className:"col3-3" },
						
			{name:'Green', 	openWith:'(!(<span style="color:#8ae234">|!| style="color:#8Ae234")!)', closeWith:'(!(</span>|!|)!)', className:"col4-1" },
			{name:'Green', 	openWith:'(!(<span style="color:#73d216">|!| style="color:#73d216")!)', closeWith:'(!(</span>|!|)!)', className:"col4-2" },
			{name:'Green',	openWith:'(!(<span style="color:#4e9a06">|!| style="color:#4e9aA06")!)', closeWith:'(!(</span>|!|)!)', className:"col4-3" },
						
			{name:'Blue', 	openWith:'(!(<span style="color:#729fcf">|!| style="color:#729fcf")!)', closeWith:'(!(</span>|!|)!)', className:"col5-1" },
			{name:'Blue', 	openWith:'(!(<span style="color:#3465a4">|!| style="color:#3465a4")!)', closeWith:'(!(</span>|!|)!)', className:"col5-2" },
			{name:'Blue',	openWith:'(!(<span style="color:#204a87">|!| style="color:#204a87")!)', closeWith:'(!(</span>|!|)!)', className:"col5-3" },
	
			{name:'Purple', openWith:'(!(<span style="color:#ad7fa8">|!| style="color:#ad7fa8")!)', closeWith:'(!(</span>|!|)!)', className:"col6-1" },
			{name:'Purple', openWith:'(!(<span style="color:#75507b">|!| style="color:#75507b")!)', closeWith:'(!(</span>|!|)!)', className:"col6-2" },
			{name:'Purple',	openWith:'(!(<span style="color:#5c3566">|!| style="color:#5c3566")!)', closeWith:'(!(</span>|!|)!)', className:"col6-3" },
						
			{name:'Red', openWith:'(!(<span style="color:#ef2929">|!| style="color:#ef2929")!)', closeWith:'(!(</span>|!|)!)', className:"col7-1" },
			{name:'Red', openWith:'(!(<span style="color:#cc0000">|!| style="color:#cc0000")!)', closeWith:'(!(</span>|!|)!)', className:"col7-2" },
			{name:'Red', openWith:'(!(<span style="color:#a40000">|!| style="color:#a40000")!)', closeWith:'(!(</span>|!|)!)', className:"col7-3" },
						
			{name:'Gray', openWith:'(!(<span style="color:#fff">|!| style="color:#fff")!)', closeWith:'(!(</span>|!|)!)', className:"col8-1" },
			{name:'Gray', openWith:'(!(<span style="color:#D3D7CF">|!| style="color:#D3D7CF")!)', closeWith:'(!(</span>|!|)!)', className:"col8-2" },
			{name:'Gray', openWith:'(!(<span style="color:#BABDB6">|!| style="color:#BABDB6")!)', closeWith:'(!(</span>|!|)!)', className:"col8-3" },
						
			{name:'Gray', openWith:'(!(<span style="color:#888A85">|!| style="color:#888A85")!)', closeWith:'(!(</span>|!|)!)', className:"col9-1" },
			{name:'Gray', openWith:'(!(<span style="color:#555753">|!| style="color:#555753")!)', closeWith:'(!(</span>|!|)!)', className:"col9-2" },
			{name:'Gray', openWith:'(!(<span style="color:#000000">|!| style="color:#000000")!)', closeWith:'(!(</span>|!|)!)', className:"col9-3" },
			
			{name:'JAKColor', openWith:'(!(<span style="color:#db6c27">|!| style="color:#db6c27")!)', closeWith:'(!(</span>|!|)!)', className:"col10-1" },
			{name:'JAKColor', openWith:'(!(<span style="color:#df1f26">|!| style="color:#df1f26")!)', closeWith:'(!(</span>|!|)!)', className:"col10-2" },
			{name:'JAKColor', openWith:'(!(<span style="color:#70aa42">|!| style="color:#70aa42")!)', closeWith:'(!(</span>|!|)!)', className:"col10-3" }
		] },
		
		{name:'Picture', key:'P', replaceWith:'<img src="[![Source:!:http://]!]" alt="[![Alternative text]!]" />' },
		{name:'Link', key:'L', openWith:'<a href="[![Link:!:http://]!]"(!( title="[![Title]!]")!)>', closeWith:'</a>', placeHolder:'Your text to link...' },
		{name:'iManager', beforeInsert:function() {
		    $.colorbox({
		        	href: "../../js/teditor/plugins/filemanager/dialog.php?type=1&editor=mce_0&lang=eng&fldr=&field_id=jakEditor2&editor=1",
		        	iframe: true,
		        	width: 800,
		        	height: 630
		        });
		      } },
		    {name:'fManager', beforeInsert:function() {
		        $.colorbox({
		        	href: "../../js/teditor/plugins/filemanager/dialog.php?type=2&editor=mce_0&lang=eng&fldr=&field_id=jakEditor2&editor=1",
		        	iframe: true,
		        	width: 800,
		        	height: 630
		        });
		  } },
		{separator:'---------------' },
		{name:'Row Fluid', className:'fluid', openWith:'<div class="row-fluid">', closeWith:'</div>', placeHolder:'Your Grid inside here...' },
		{name:'Grid', className:'grid', dropMenu: [
			{name:'Grid 1', openWith:'<div class="span1">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 2', openWith:'<div class="span2">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 3', openWith:'<div class="span3">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 4 (1/3)', openWith:'<div class="span4">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 5', openWith:'<div class="span5">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 6 (1/2)', openWith:'<div class="span6">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 7', openWith:'<div class="span7">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 8 (2/3)', openWith:'<div class="span8">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 9', openWith:'<div class="span9">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 10', openWith:'<div class="span10">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 11', openWith:'<div class="span11">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 12', openWith:'<div class="span12">', closeWith:'</div>', placeHolder:'Your content here...' }
		] },
		{name:'Offset', className:'offset', dropMenu: [
			{name:'Offset 1', replaceWith:'class="offset1"' },
			{name:'Offset 2', replaceWith:'class="offset2"' },
			{name:'Offset 3', replaceWith:'class="offset3"' },
			{name:'Offset 4', replaceWith:'class="offset4"' },
			{name:'Offset 5', replaceWith:'class="offset5"' },
			{name:'Offset 6', replaceWith:'class="offset6"' },
			{name:'Offset 7', replaceWith:'class="offset7"' },
			{name:'Offset 8', replaceWith:'class="offset8"' },
			{name:'Offset 9', replaceWith:'class="offset9"' },
			{name:'Offset 10', replaceWith:'class="offset10"' },
			{name:'Offset 11', replaceWith:'class="offset11"' },
			{name:'Offset 12', replaceWith:'class="offset12"' }
		] },
		{name:'Add CSS', className:'css', dropMenu: [
			{name:'Hero Head', openWith:'<div class="hero-unit">', closeWith:'</div>', placeHolder:'Your content here…' },
			{name:'Well, well...', openWith:'<div class="well">', closeWith:'</div>', placeHolder:'Your content here…' },
			{name:'Thumbnails', replaceWith:'<ul class="thumbnails"><li class="span4"><div class="thumbnail">Your Image goes here...<div class="caption"><h3>Thumbnail label</h3><p>Thumbnail caption...</p></div></div></li></ul>' },
			{name:'Circle Image', replaceWith:'class="img-circle"' },
			{name:'Rounded Image', replaceWith:'class="img-rounded"' },
			{name:'Polaroid Image', replaceWith:'class="img-polaroid"' },
			{name:'LightBox', replaceWith:'class="lightbox"' },
			{name:'Progress Bar', replaceWith:'<div class="progress progress-striped active"><div class="bar" style="width: 40%;"></div></div>' },
			{name:'Label', openWith:'<span class="label">', closeWith:'</span>', placeHolder:'Your content here…' },
			{name:'Badges', openWith:'<span class="badge">', closeWith:'</span>', placeHolder:'Your content here…' },
			{name:'Success', openWith:'<div class="alert alert-success alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Info', openWith:'<div class="alert alert-info alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Alert', openWith:'<div class="alert alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Error', openWith:'<div class="alert alert-error alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Code', replaceWith:'<pre><code>[![Source:!:Your text here...]!]</code></pre>' }
		] },
		{separator:'---------------' },
		{name:'Clean', className:'clean', replaceWith:function(jakcmsE) { return jakcmsE.selection.replace(/<(.*?)>/g, "") } },
		{name:'Preview', className:'preview', call:'preview' }
		]
}

jakHTMLeditor3 = {
	nameSpace:       "html", // Useful to prevent multi-instances CSS conflict
	onShiftEnter:	{keepDefault:false, replaceWith:'<br />\n'},
	onCtrlEnter:	{keepDefault:false, openWith:'\n<p>', closeWith:'</p>\n'},
	onTab:			{keepDefault:false, openWith:'	 '},
	markupSet: [
		{name:'Save', className:'save', beforeInsert:function(jakcmsE) { miu.save(jakcmsE) } },
		{name:'Load', className:'load', beforeInsert:function(jakcmsE) { miu.load(jakcmsE) } },
		{separator:'---------------' },
	{name:'Headings', className:'headings', dropMenu: [
		{name:'Heading 1', key:'1', openWith:'<h1(!( class="[![Class]!]")!)>', closeWith:'</h1>', placeHolder:'Your title here...', className:'h1' },
		{name:'Heading 2', key:'2', openWith:'<h2(!( class="[![Class]!]")!)>', closeWith:'</h2>', placeHolder:'Your title here...', className:'h2' },
		{name:'Heading 3', key:'3', openWith:'<h3(!( class="[![Class]!]")!)>', closeWith:'</h3>', placeHolder:'Your title here...', className:'h3' },
		{name:'Heading 4', key:'4', openWith:'<h4(!( class="[![Class]!]")!)>', closeWith:'</h4>', placeHolder:'Your title here...', className:'h4' },
		{name:'Heading 5', key:'5', openWith:'<h5(!( class="[![Class]!]")!)>', closeWith:'</h5>', placeHolder:'Your title here...', className:'h5' },
		{name:'Heading 6', key:'6', openWith:'<h6(!( class="[![Class]!]")!)>', closeWith:'</h6>', placeHolder:'Your title here...', className:'h6' }
	] },
	{name:'Fonts', className:'font', dropMenu: [
	    { name:'Arial', openWith:'(!(<span class="farial">|!| class="farial")!)', closeWith:'(!(</span>|!|)!)', className:"font-1" },
	    { name:'Helvetica', openWith:'(!(<span class="fhelvetica">|!| class="fhelvetica")!)', closeWith:'(!(</span>|!|)!)', className:"font-2" },
	    { name:'Times New Roman', openWith:'(!(<span class="ftimes">|!| class="ftimes")!)', closeWith:'(!(</span>|!|)!)', className:"font-3" },
	    { name:'Trebuchet MS', openWith:'(!(<span class="ftrebuchet">|!| class="ftrebuchet")!)', closeWith:'(!(</span>|!|)!)', className:"font-4" },
	    { name:'Verdana', openWith:'(!(<span class="fverdana">|!| class="fverdana")!)', closeWith:'(!(</span>|!|)!)', className:"font-5" },
	] },
	{name:'Paragraph', openWith:'<p(!( class="[![Class]!]")!)>', closeWith:'</p>' },
	{separator:'---------------' },
	{name:'Bold', key:'B', openWith:'(!(<strong>|!|<b>)!)', closeWith:'(!(</strong>|!|</b>)!)' },
	{name:'Italic', key:'I', openWith:'(!(<em>|!|<i>)!)', closeWith:'(!(</em>|!|</i>)!)' },
	{name:'Stroke through', key:'S', openWith:'<del>', closeWith:'</del>' },
	{separator:'---------------' },
	{name:'Alignments', className:'alignments', dropMenu:[
		{name:'Left', openWith:'(!(<p class="ftleft">|!| class="ftleft")!)', closeWith:'(!(</p>|!|)!)', className:'left' },
		{name:'Center', openWith:'(!(<p class="ftcenter">|!| class="ftcenter")!)', closeWith:'(!(</p>|!|)!)', className:'center' },
		{name:'Right', openWith:'(!(<p class="ftright;">|!| class="ftright;")!)', closeWith:'(!(</p>|!|)!)', className:'right' },
		{name:'Justify', openWith:'(!(<p class="ftjustify">|!| class="ftjustify")!)', closeWith:'(!(</p>|!|)!)', className:'justify' }
		]
	},
	{separator:'---------------' },
	{name:'Ul', openWith:'<ul>\n<li>', closeWith:'</li>\n</ul>\n' },
	{name:'Ol', openWith:'<ol>\n<li>', closeWith:'</li>\n</ol>\n' },
	{name:'Li', openWith:'<li>', closeWith:'</li>' },
	{separator:'---------------' },
	{name:'Smiley', className:'smilies', dropMenu:[
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-cool.png" alt="smiley-cool" />', className:'s-1' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-cry.png" alt="smiley-cry" />', className:'s-2' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-frown.png" alt="smiley-frown" />', className:'s-3' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-kiss.png" alt="smiley-kiss" />', className:'s-4' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-laughing.png" alt="smiley-laughing" />', className:'s-5' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-mouth.png" alt="smiley-mouth" />', className:'s-6' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-sealed.png" alt="smiley-sealed" />', className:'s-7' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-shout.png" alt="smiley-shout" />', className:'s-8' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-smile.png" alt="smiley-smile" />', className:'s-9' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-tongue.png" alt="smiley-tongue" />', className:'s-10' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-undecided.png" alt="smiley-undecided" />', className:'s-11' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-unhappy.png" alt="smiley-unhappy" />', className:'s-12' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-weird.png" alt="smiley-weird" />', className:'s-13' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-what.png" alt="smiley-what" />', className:'s-14' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-wink.png" alt="smiley-wink" />', className:'s-15' },
		{name:'Left', replaceWith:'<img src="'+jakCMS.jakcms_url_orig+'img/smilies/smiley-yell.png" alt="smiley-yell" />', className:'s-16' }
	] },
	{name:'Colors', className:'palette', dropMenu: [
			{name:'Yellow',	openWith:'(!(<span style="color:#FCE94F">|!| style="color:#FCE94F")!)', closeWith:'(!(</span>|!|)!)', className:"col1-1" },
			{name:'Yellow',	openWith:'(!(<span style="color:#EDD400">|!| style="color:#EDD400")!)', closeWith:'(!(</span>|!|)!)', className:"col1-2" },
			{name:'Yellow', openWith:'(!(<span style="color:#C4A000">|!| style="color:#C4A000")!)', closeWith:'(!(</span>|!|)!)', className:"col1-3" },
						
			{name:'Orange', openWith:'(!(<span style="color:#FCAF3E">|!| style="color:#FCAF3E")!)', closeWith:'(!(</span>|!|)!)', className:"col2-1" },
			{name:'Orange', openWith:'(!(<span style="color:#F57900">|!| style="color:#F57900")!)', closeWith:'(!(</span>|!|)!)', className:"col2-2" },
			{name:'Orange', openWith:'(!(<span style="color:#CE5C00">|!| style="color:#CE5C00")!)', closeWith:'(!(</span>|!|)!)', className:"col2-3" },
						
			{name:'Brown', 	openWith:'(!(<span style="color:#E9B96E">|!| style="color:#E9B96E")!)', closeWith:'(!(</span>|!|)!)', className:"col3-1" },
			{name:'Brown', 	openWith:'(!(<span style="color:#C17D11">|!| style="color:#C17D11")!)', closeWith:'(!(</span>|!|)!)', className:"col3-2" },
			{name:'Brown',	openWith:'(!(<span style="color:#8F5902">|!| style="color:#8F5902")!)', closeWith:'(!(</span>|!|)!)', className:"col3-3" },
						
			{name:'Green', 	openWith:'(!(<span style="color:#8ae234">|!| style="color:#8Ae234")!)', closeWith:'(!(</span>|!|)!)', className:"col4-1" },
			{name:'Green', 	openWith:'(!(<span style="color:#73d216">|!| style="color:#73d216")!)', closeWith:'(!(</span>|!|)!)', className:"col4-2" },
			{name:'Green',	openWith:'(!(<span style="color:#4e9a06">|!| style="color:#4e9aA06")!)', closeWith:'(!(</span>|!|)!)', className:"col4-3" },
						
			{name:'Blue', 	openWith:'(!(<span style="color:#729fcf">|!| style="color:#729fcf")!)', closeWith:'(!(</span>|!|)!)', className:"col5-1" },
			{name:'Blue', 	openWith:'(!(<span style="color:#3465a4">|!| style="color:#3465a4")!)', closeWith:'(!(</span>|!|)!)', className:"col5-2" },
			{name:'Blue',	openWith:'(!(<span style="color:#204a87">|!| style="color:#204a87")!)', closeWith:'(!(</span>|!|)!)', className:"col5-3" },
	
			{name:'Purple', openWith:'(!(<span style="color:#ad7fa8">|!| style="color:#ad7fa8")!)', closeWith:'(!(</span>|!|)!)', className:"col6-1" },
			{name:'Purple', openWith:'(!(<span style="color:#75507b">|!| style="color:#75507b")!)', closeWith:'(!(</span>|!|)!)', className:"col6-2" },
			{name:'Purple',	openWith:'(!(<span style="color:#5c3566">|!| style="color:#5c3566")!)', closeWith:'(!(</span>|!|)!)', className:"col6-3" },
						
			{name:'Red', openWith:'(!(<span style="color:#ef2929">|!| style="color:#ef2929")!)', closeWith:'(!(</span>|!|)!)', className:"col7-1" },
			{name:'Red', openWith:'(!(<span style="color:#cc0000">|!| style="color:#cc0000")!)', closeWith:'(!(</span>|!|)!)', className:"col7-2" },
			{name:'Red', openWith:'(!(<span style="color:#a40000">|!| style="color:#a40000")!)', closeWith:'(!(</span>|!|)!)', className:"col7-3" },
						
			{name:'Gray', openWith:'(!(<span style="color:#fff">|!| style="color:#fff")!)', closeWith:'(!(</span>|!|)!)', className:"col8-1" },
			{name:'Gray', openWith:'(!(<span style="color:#D3D7CF">|!| style="color:#D3D7CF")!)', closeWith:'(!(</span>|!|)!)', className:"col8-2" },
			{name:'Gray', openWith:'(!(<span style="color:#BABDB6">|!| style="color:#BABDB6")!)', closeWith:'(!(</span>|!|)!)', className:"col8-3" },
						
			{name:'Gray', openWith:'(!(<span style="color:#888A85">|!| style="color:#888A85")!)', closeWith:'(!(</span>|!|)!)', className:"col9-1" },
			{name:'Gray', openWith:'(!(<span style="color:#555753">|!| style="color:#555753")!)', closeWith:'(!(</span>|!|)!)', className:"col9-2" },
			{name:'Gray', openWith:'(!(<span style="color:#000000">|!| style="color:#000000")!)', closeWith:'(!(</span>|!|)!)', className:"col9-3" },
			
			{name:'JAKColor', openWith:'(!(<span style="color:#db6c27">|!| style="color:#db6c27")!)', closeWith:'(!(</span>|!|)!)', className:"col10-1" },
			{name:'JAKColor', openWith:'(!(<span style="color:#df1f26">|!| style="color:#df1f26")!)', closeWith:'(!(</span>|!|)!)', className:"col10-2" },
			{name:'JAKColor', openWith:'(!(<span style="color:#70aa42">|!| style="color:#70aa42")!)', closeWith:'(!(</span>|!|)!)', className:"col10-3" }
		] },
		
		{name:'Picture', key:'P', replaceWith:'<img src="[![Source:!:http://]!]" alt="[![Alternative text]!]" />' },
		{name:'Link', key:'L', openWith:'<a href="[![Link:!:http://]!]"(!( title="[![Title]!]")!)>', closeWith:'</a>', placeHolder:'Your text to link...' },
		{name:'iManager', beforeInsert:function() {
			$.colorbox({
			    	href: "../../js/teditor/plugins/filemanager/dialog.php?type=1&editor=mce_0&lang=eng&fldr=&field_id=jakEditor3&editor=1",
			    	iframe: true,
			    	width: 800,
			    	height: 630
			    });
			  } },
			{name:'fManager', beforeInsert:function() {
			    $.colorbox({
			    	href: "../../js/teditor/plugins/filemanager/dialog.php?type=2&editor=mce_0&lang=eng&fldr=&field_id=jakEditor3&editor=1",
			    	iframe: true,
			    	width: 800,
			    	height: 630
			    });
		  } },
		{separator:'---------------' },
		{name:'Row Fluid', className:'fluid', openWith:'<div class="row-fluid">', closeWith:'</div>', placeHolder:'Your Grid inside here...' },
		{name:'Grid', className:'grid', dropMenu: [
			{name:'Grid 1', openWith:'<div class="span1">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 2', openWith:'<div class="span2">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 3', openWith:'<div class="span3">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 4 (1/3)', openWith:'<div class="span4">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 5', openWith:'<div class="span5">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 6 (1/2)', openWith:'<div class="span6">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 7', openWith:'<div class="span7">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 8 (2/3)', openWith:'<div class="span8">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 9', openWith:'<div class="span9">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 10', openWith:'<div class="span10">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 11', openWith:'<div class="span11">', closeWith:'</div>', placeHolder:'Your content here...' },
			{name:'Grid 12', openWith:'<div class="span12">', closeWith:'</div>', placeHolder:'Your content here...' }
		] },
		{name:'Offset', className:'offset', dropMenu: [
			{name:'Offset 1', replaceWith:'class="offset1"' },
			{name:'Offset 2', replaceWith:'class="offset2"' },
			{name:'Offset 3', replaceWith:'class="offset3"' },
			{name:'Offset 4', replaceWith:'class="offset4"' },
			{name:'Offset 5', replaceWith:'class="offset5"' },
			{name:'Offset 6', replaceWith:'class="offset6"' },
			{name:'Offset 7', replaceWith:'class="offset7"' },
			{name:'Offset 8', replaceWith:'class="offset8"' },
			{name:'Offset 9', replaceWith:'class="offset9"' },
			{name:'Offset 10', replaceWith:'class="offset10"' },
			{name:'Offset 11', replaceWith:'class="offset11"' },
			{name:'Offset 12', replaceWith:'class="offset12"' }
		] },
		{name:'Add CSS', className:'css', dropMenu: [
			{name:'Hero Head', openWith:'<div class="hero-unit">', closeWith:'</div>', placeHolder:'Your content here…' },
			{name:'Well, well...', openWith:'<div class="well">', closeWith:'</div>', placeHolder:'Your content here…' },
			{name:'Thumbnails', replaceWith:'<ul class="thumbnails"><li class="span4"><div class="thumbnail">Your Image goes here...<div class="caption"><h3>Thumbnail label</h3><p>Thumbnail caption...</p></div></div></li></ul>' },
			{name:'Circle Image', replaceWith:'class="img-circle"' },
			{name:'Rounded Image', replaceWith:'class="img-rounded"' },
			{name:'Polaroid Image', replaceWith:'class="img-polaroid"' },
			{name:'LightBox', replaceWith:'class="lightbox"' },
			{name:'Progress Bar', replaceWith:'<div class="progress progress-striped active"><div class="bar" style="width: 40%;"></div></div>' },
			{name:'Label', openWith:'<span class="label">', closeWith:'</span>', placeHolder:'Your content here…' },
			{name:'Badges', openWith:'<span class="badge">', closeWith:'</span>', placeHolder:'Your content here…' },
			{name:'Success', openWith:'<div class="alert alert-success alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Info', openWith:'<div class="alert alert-info alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Alert', openWith:'<div class="alert alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Error', openWith:'<div class="alert alert-error alert-block fade in"><button type="button" class="close" data-dismiss="alert">×</button>', closeWith:'</div>', placeHolder:'<h4>Warning!</h4>This is your alert...' },
			{name:'Code', replaceWith:'<pre><code>[![Source:!:Your text here...]!]</code></pre>' }
		] },
		{separator:'---------------' },
		{name:'Clean', className:'clean', replaceWith:function(jakcmsE) { return jakcmsE.selection.replace(/<(.*?)>/g, "") } },
		{name:'Preview', className:'preview', call:'preview' }
		]
}

// mIu nameSpace to avoid conflict.
miu = {
    save: function(jakcmsE) {
        var data = encodeURIComponent(jakcmsE.textarea.value); // Thx Gregory LeRoy
        var ok = confirm("Save the content?");
        if (!ok) {
            return false;
        }
        $.post(jakcmsE.root+"utils/quicksave/save.php", "data="+data, function(response) {
                if(response === "MIU:OK") {
                    alert("Saved!");
                }
            }
        ); 
    },
	
    load: function(jakcmsE) {
        $.get(jakcmsE.root+"utils/quicksave/load.php", function(response) {
                if(response === "MIU:EMPTY") {
                    alert("Nothing to load");
                } else {
                    var ok = confirm("Load the previously saved content?");
                    if (!ok) {
                        return false;
                    }
                    jakcmsE.textarea.value = response;
                    // alert("Loaded!");
                }
            }
        );
    }  
}