<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

// Check if the file is accessed only via index.php if not stop the script from running
if (!defined('JAK_ADMIN_PREVENT_ACCESS')) die('You cannot access this file directly.');

// Check if the user has access to this file
if (!JAK_USERID_CMS || !$jakuser->jakModuleaccess(JAK_USERID_CMS, JAK_ACCESSNEWS)) jak_redirect(BASE_URL);

// All the tables we need for this plugin
$errors = array();
$jaktable = DB_PREFIX.'news';
$jaktable1 = DB_PREFIX.'contactform';
$jaktable2 = DB_PREFIX.'pagesgrid';
$jaktable3 = DB_PREFIX.'pluginhooks';

// Call the hooks per name for the template
$JAK_HOOK_ADMIN_PAGE = $jakhooks->jakGethook("tpl_admin_page_news");
$JAK_HOOK_ADMIN_PAGE_NEW = $jakhooks->jakGethook("tpl_admin_page_news_new");

// Now start with the plugin use a switch to access all pages
switch ($page1) {

	// Create new blog
	case 'new':
	
		// Important template Stuff
		$JAK_CONTACT_FORMS = jak_get_page_info($jaktable1, '');
	
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		        $defaults = $_POST;
		
		    if (empty($defaults['jak_title'])) $errors['e1'] = $tl['error']['e2'];
		    
		    if (!empty($defaults['jak_datefrom'])) {
		    
		    	list($yearf, $monthf, $dayf) = explode('-', $defaults['jak_datefrom']);
		    	$finalfrom = mktime($defaults['jak_timefrom'], $defaults['jak_timefromm'], 0, $monthf, $dayf, $yearf);
		    	
		    }
		    
		    if (!empty($defaults['jak_dateto'])) {
		    		
		    	list($yeart, $montht, $dayt) = explode('-', $defaults['jak_dateto']);
		    	$finalto = mktime($defaults['jak_timeto'], $defaults['jak_timetom'], 0, $montht, $dayt, $yeart);
		    	
		    }
		    
		    if (isset($finalto) && isset($finalfrom) && $finalto < $finalfrom) {
		    	$errors['e2'] = $tl['error']['e28'];
		    }
		    
		    // Now do the dirty stuff in mysql
		    if (count($errors) == 0) {
		    
		    // Write some standard vars if empty
		    if (!isset($defaults['jak_showcontact'])) $defaults['jak_showcontact'] = 0;
		    
		    if (!isset($defaults['jak_showtitle'])) $defaults['jak_showtitle'] = 0;
		    
		    if (!isset($defaults['jak_showdate'])) $defaults['jak_showdate'] = 0;
		    
		    if (!isset($defaults['jak_social'])) $defaults['jak_social'] = 0;
		    
		    if (empty($defaults['jak_img'])) $defaults['jak_img'] = '';
		    
		    // save the time if available
		    if (isset($finalfrom)) {
		    	$insert .= 'startdate = "'.$finalfrom.'",';
		    }
		    
		    if (isset($finalto)) {
		    	$insert .= 'enddate = "'.$finalto.'",';
		    }
		    
		    if (!isset($defaults['jak_permission'])) {
		    	$permission = 0;
		    } else {
		    	$permission = join(',', $defaults['jak_permission']);
		    }
		    
		    // Get the php hook for display stuff in pages
		    $hooknews = $jakhooks->jakGethook("php_admin_news_sql");
		    if ($hooknews) { foreach($hooknews as $hne)
		    {
		    	eval($hne['phpcode']);
		    }
		    }
		
			$result = $jakdb->query('INSERT INTO '.$jaktable.' SET 
			title = "'.smartsql($defaults['jak_title']).'",
			title_l2 = "'.smartsql($defaults['jak_title2']).'",
			title_l3 = "'.smartsql($defaults['jak_title3']).'",
			content = "'.smartsql($defaults['jak_content']).'",
			content_l2 = "'.smartsql($defaults['jak_content2']).'",
			content_l3 = "'.smartsql($defaults['jak_content3']).'",
			news_css = "'.smartsql($defaults['jak_css']).'",
			news_javascript = "'.smartsql($defaults['jak_javascript']).'",
			sidebar = "'.smartsql($defaults['jak_sidebar']).'",
			previmg = "'.$defaults['jak_img'].'",
			showtitle = "'.$defaults['jak_showtitle'].'",
			showcontact = "'.$defaults['jak_showcontact'].'",
			showdate = "'.$defaults['jak_showdate'].'",
			socialbutton = "'.$defaults['jak_social'].'",
			showvote = "'.$defaults['jak_vote'].'",
			newsorder = 1,
			time = NOW(),
			permission = "'.$permission.'",
			'.$insert.'
			active = 1');
			
			$rowid = $jakdb->jak_last_id();
			
			// Save order for extra stuff
			$exorder = $defaults['corder_new'];
			$pluginid = $defaults['real_plugin_id'];
			$realid = implode(',', $defaults['real_plugin_id']);
			$doit = array_combine($pluginid, $exorder);
			
			foreach ($doit as $key => $exorder) {
			
				$jakdb->query('INSERT INTO '.$jaktable2.' SET newsid = "'.$rowid.'", pluginid = "'.$key.'", orderid = "'.$exorder.'"');
			
			}
			
			// Save order for sidebar widget
			if (is_array($defaults['jak_hookshow'])) {
			$exorder = $defaults['horder'];
			$hookid = $defaults['real_hook_id'];
			$plugind = $defaults['sreal_plugin_id'];
			$doith = array_combine($hookid, $exorder);
			$pdoith = array_combine($hookid, $plugind);
			
			foreach ($doith as $key => $exorder) {
			
				if (in_array($key, $defaults['jak_hookshow'])) {
				
					// Get the real what id
					$whatid = $defaults['whatid_'.$pdoith[$key]];	
					
					if (!$whatid) $whatid = 0;
			
					$jakdb->query('INSERT INTO '.$jaktable2.' SET newsid = "'.$rowid.'", hookid = "'.$key.'", pluginid = "'.$pdoith[$key].'", whatid = "'.$whatid.'", orderid = "'.$exorder.'"');
				
				}
			
			}
			
			}
			
			// Now let us delete the news cache file
			$cachenewsfile = '../'.JAK_CACHE_DIRECTORY.'/';
			$msfi = glob($cachenewsfile."news*.php");
			if ($msfi) foreach ($msfi as $filen) {
			    if (file_exists($filen)) {
			    	unlink($filen);
			    }
			}
		
			if (!$result) {
		    	jak_redirect(BASE_URL.'index.php?p=news&sp=new&ssp=e');
			} else {
				
				// Create Tags if the module is active
				if (!empty($defaults['jak_tags'])) {
					// check if tag does not exist and insert in cloud
			        JAK_tags::jakBuildcloud($defaults['jak_tags'], $rowid, 1);
			        // insert tag for normal use
			        JAK_tags::jakInsertags($defaults['jak_tags'], $rowid, 1, 1);
			        
			        // Now let us delete the tag cache file
			        $cachetagfile = '../'.JAK_CACHE_DIRECTORY.'/tags.php';
			        if (file_exists($cachetagfile)) {
			        	unlink($cachetagfile);
			        }
		}		
		        jak_redirect(BASE_URL.'index.php?p=news&sp=edit&ssp='.$rowid.'&sssp=s');
		    }
		 } else {
		    
		   	$errors['e'] = $tl['error']['e'];
		    $errors = $errors;
		    }
		}
		
		// Get the sidebar templates
		$result = $jakdb->query('SELECT id, name, widgetcode, exorder, pluginid FROM '.$jaktable3.' WHERE hook_name = "tpl_sidebar" AND active = 1 ORDER BY exorder ASC');
		while ($row = $result->fetch_assoc()) {
			$plhooks[] = $row;
		}
		// Get all plugins out the databse
		$JAK_HOOKS = $plhooks;
		
		// Get active sidebar widgets
		$grid = $jakdb->query('SELECT hookid FROM '.$jaktable2.' WHERE plugin = 1 ORDER BY orderid ASC');
		while ($grow = $grid->fetch_assoc()) {
		        // collect each record into $_data
		        $actgrid[] = $grow;
		}
		
		$JAK_ACTIVE_GRID = $actgrid;
		
		// Get the php hook for display stuff in pages
		$hookpagei = $jakhooks->jakGethook("php_admin_pages_news_info");
		if ($hookpagei) { foreach($hookpagei as $hpagi)
		{
			eval($hpagi['phpcode']);
		}
		}
		
		// Get all usergroup's
		$JAK_USERGROUP = jak_get_usergroup_all('usergroup');
		
		// Call the template
		$template = 'newnews.php';
	
	break;
	case 'setting':
	
		// Important template Stuff
		$JAK_SETTING = jak_get_setting('news');
		
		// Let's go on with the script
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		    $defaults = $_POST;
		    
		    if (empty($defaults['jak_date'])) { $errors['e1'] = $tl['error']['e4']; }
		    
		    if (!is_numeric($defaults['jak_item'])) { $errors['e2'] = $tl['error']['e15']; }
		    
		    if (!is_numeric($defaults['jak_mid'])) { $errors['e3'] = $tl['error']['e15']; }
		
		    if (count($errors) == 0) {
		    
		    // Do the dirty work in mysql
		    
		    $sql = 'UPDATE '.DB_PREFIX.'setting SET value = CASE varname
		    	WHEN "newstitle" THEN "'.smartsql($defaults['jak_title']).'"
		    	WHEN "newstitle_l2" THEN "'.smartsql($defaults['jak_title2']).'"
		    	WHEN "newstitle_l3" THEN "'.smartsql($defaults['jak_title3']).'"
		    	WHEN "newsdesc" THEN "'.smartsql($defaults['jak_lcontent']).'"
		    	WHEN "newsdesc_l2" THEN "'.smartsql($defaults['jak_lcontent2']).'"
		    	WHEN "newsdesc_l3" THEN "'.smartsql($defaults['jak_lcontent3']).'"
		    	WHEN "newsdateformat" THEN "'.smartsql($defaults['jak_date']).'"
		    	WHEN "newstimeformat" THEN "'.smartsql($defaults['jak_time']).'"
		    	WHEN "newspagemid" THEN "'.smartsql($defaults['jak_mid']).'"
		    	WHEN "newspageitem" THEN "'.smartsql($defaults['jak_item']).'"
		    	WHEN "news_css" THEN "'.smartsql($defaults['jak_css']).'"
		    	WHEN "news_javascript" THEN "'.smartsql($defaults['jak_javascript']).'"     
		    END
				WHERE varname IN ("newstitle","newstitle_l2","newstitle_l3", "newsdesc","newsdesc_l2","newsdesc_l3", "newsdateformat", "newstimeformat", "newspagemid", "newspageitem","news_css","news_javascript")';
				$result = $jakdb->query($sql);
				
			// Save order for sidebar widget
			if (is_array($defaults['jak_hookshow_new'])) {
			
				$exorder = $defaults['horder_new'];
				$hookid = $defaults['real_hook_id_new'];
				$plugind = $defaults['sreal_plugin_id_new'];
				$doith = array_combine($hookid, $exorder);
				$pdoith = array_combine($hookid, $plugind);
				
				foreach ($doith as $key => $exorder) {
				
					if (in_array($key, $defaults['jak_hookshow_new'])) {
						
						// Get the real what id
						$whatid = $defaults['whatid_'.$pdoith[$key]];	
						
						if (!$whatid) $whatid = 0;
						
						$jakdb->query('INSERT INTO '.$jaktable2.' SET plugin = 1, hookid = "'.$key.'", pluginid = "'.$pdoith[$key].'", whatid = "'.$whatid.'", orderid = "'.$exorder.'"');
					
					}
				
				}
			
			}
			
			// Now check if all the sidebar a deselct and hooks exist, if so delete all associated to this page
			$result = $jakdb->query('SELECT id FROM '.$jaktable2.' WHERE plugin = 1 AND hookid != 0');
				$row = $result->fetch_assoc();
			
			if (!is_array($defaults['jak_hookshow_new']) && $row['id'] && !is_array($defaults['jak_hookshow'])) {
			
				$jakdb->query('DELETE FROM '.$jaktable2.' WHERE plugin = 1 AND hookid != 0');
			
			}
				
			// Save order or delete for extra sidebar widget
			if (is_array($defaults['jak_hookshow'])) {
			
				$exorder = $defaults['horder'];
				$hookid = $defaults['real_hook_id'];
				$hookrealid = implode(',', $defaults['real_hook_id']);
				$doith = array_combine($hookid, $exorder);
				
				foreach ($doith as $key => $exorder) {
				
					// Get the real what id
					$result = $jakdb->query('SELECT pluginid FROM '.$jaktable2.' WHERE id = "'.smartsql($key).'" AND hookid != 0');
					$row = $result->fetch_assoc();
						
					$whatid = $defaults['whatid_'.$row["pluginid"]];
						
					if (!$whatid) $whatid = 0;
						
						if (in_array($key, $defaults['jak_hookshow'])) {
							$updatesql .= sprintf("WHEN %d THEN %d ", $key, $exorder);
							$updatesql1 .= sprintf("WHEN %d THEN %d ", $key, $whatid);
							
						} else {
							$jakdb->query('DELETE FROM '.$jaktable2.' WHERE id = '.$key.'');
						}
					}
					
					$jakdb->query('UPDATE '.$jaktable2.' SET orderid = CASE id
					'.$updatesql.'
					END
					WHERE id IN ('.$hookrealid.')');
					
					$jakdb->query('UPDATE '.$jaktable2.' SET whatid = CASE id
					'.$updatesql1.'
					END
					WHERE id IN ('.$hookrealid.')');
			
			}
			
			// Now let us delete the define cache file
			$cachedefinefile = '../'.JAK_CACHE_DIRECTORY.'/define.php';
			if (file_exists($cachedefinefile)) {
				unlink($cachedefinefile);
			}
				
			if (!$result) {
				jak_redirect(BASE_URL.'index.php?p=news&sp=setting&ssp=e');
			} else {
		        jak_redirect(BASE_URL.'index.php?p=news&sp=setting&ssp=s');
		    }
		    } else {
		    
		   	$errors['e'] = $tl['error']['e'];
		    $errors = $errors;
		    }
		}
		
		// Get the sort orders for the grid
		$grid = $jakdb->query('SELECT id, hookid, whatid, orderid FROM '.$jaktable2.' WHERE plugin = 1 ORDER BY orderid ASC');
		while ($grow = $grid->fetch_assoc()) {
		        // collect each record into $_data
		        $pagegrid[] = $grow;
		}
		
		$JAK_PAGE_GRID = $pagegrid;
		
		
		// Get the sidebar templates
		$result = $jakdb->query('SELECT id, name, widgetcode, exorder, pluginid FROM '.$jaktable3.' WHERE hook_name = "tpl_sidebar" AND active = 1 ORDER BY exorder ASC');
		while ($row = $result->fetch_assoc()) {
			$plhooks[] = $row;
		}
		// Get all plugins out the databse
		$JAK_HOOKS = $plhooks;
		
		// Get the php hook for display stuff in pages
		$hookpagei = $jakhooks->jakGethook("php_admin_pages_news_info");
		if ($hookpagei) { foreach($hookpagei as $hpagi)
		{
			eval($hpagi['phpcode']);
		}
		}
		
		// Get the special vars for multi language support
		$JAK_FORM_DATA["title"] = JAK_NEWSTITLE;
		$JAK_FORM_DATA["title_l2"] = JAK_NEWSTITLE_L2;
		$JAK_FORM_DATA["title_l3"] = JAK_NEWSTITLE_L3;
		$JAK_FORM_DATA["content"] = JAK_NEWSDESC;
		$JAK_FORM_DATA["content_l2"] = JAK_NEWSDESC_L2;
		$JAK_FORM_DATA["content_l3"] = JAK_NEWSDESC_L3;
		
		// Call the template
		$template = 'newssetting.php';
		
	break;
	default:
		
		// Important template Stuff
		$JAK_CONTACT_FORMS = jak_get_page_info($jaktable1, '');

		switch ($page1) {
    	case 'lock':
	        if (is_numeric($page2) && jak_row_exist($page2,$jaktable)) {
	                
		    $sql = 'UPDATE '.$jaktable.' SET active = IF (active = 1, 0, 1) WHERE id = "'.smartsql($page2).'"';
		    $result = $jakdb->query($sql);
	  		
	  		JAK_tags::jakLocktags($page2, 1);
	  		
	  		// Now let us delete the tag cache file
	  		$cachetagfile = '../'.JAK_CACHE_DIRECTORY.'/tags.php';
	  		if (file_exists($cachetagfile)) {
	  			unlink($cachetagfile);
	  		}
	  		
	  		// Now let us delete the news cache file
	  		$cachenewsfile = '../'.JAK_CACHE_DIRECTORY.'/';
	  		$msfi = glob($cachenewsfile."news*.php");
	  		if ($msfi) foreach ($msfi as $filen) {
	  		    if (file_exists($filen)) {
	  		    	unlink($filen);
	  		    }
	  		}
	  		
	 		if (!$result) {
				jak_redirect(BASE_URL.'index.php?p=news&sp=e');
			} else {
	        	jak_redirect(BASE_URL.'index.php?p=news&sp=s');
	    	}
	    
	    	} else {
		   		jak_redirect(BASE_URL.'index.php?p=news&sp=ene');
			}
        break;
    	case 'delete':
	        if (is_numeric($page2) && jak_row_exist($page2,$jaktable)) {
	
			$sql = 'DELETE FROM '.$jaktable.' WHERE id = "'.smartsql($page2).'"';
			$result = $jakdb->query($sql);
	
			if (!$result) {
		    	jak_redirect(BASE_URL.'index.php?p=news&sp=e');
		        exit;
			} else {
				JAK_tags::jakDeletetags($page2, 1);
				
				// Now let us delete the tag cache file
				$cachetagfile = '../'.JAK_CACHE_DIRECTORY.'/tags.php';
				if (file_exists($cachetagfile)) {
					unlink($cachetagfile);
				}
				
				// Now let us delete the news cache file
				$cachenewsfile = '../'.JAK_CACHE_DIRECTORY.'/';
				$msfi = glob($cachenewsfile."news*.php");
				if ($msfi) foreach ($msfi as $filen) {
				    if (file_exists($filen)) {
				    	unlink($filen);
				    }
				}
				
		        jak_redirect(BASE_URL.'index.php?p=news&sp=s');
	    	}
			} else {
	    		jak_redirect(BASE_URL.'index.php?p=news&sp=ene');
			}
        break;
    	case 'edit':
	        if (jak_row_exist($page2,$jaktable)) {
	
			if ($_SERVER['REQUEST_METHOD'] == 'POST') {
	    	$defaults = $_POST;
	    
		    // Delete the tags
		    if (!empty($defaults['jak_tagdelete'])) {
		    $tags = $defaults['jak_tagdelete'];
		
		        for ($i = 0; $i < count($tags); $i++) {
		            $tag = $tags[$i];
		            
		            JAK_tags::jakDeleteonetag($tag);
		            
		        }
		        
		        // Now let us delete the tag cache file
		        $cachetagfile = '../'.JAK_CACHE_DIRECTORY.'/tags.php';
		        if (file_exists($cachetagfile)) {
		        	unlink($cachetagfile);
		        }
		        
		        // Now let us delete the news cache file
		        $cachenewsfile = '../'.JAK_CACHE_DIRECTORY.'/';
		        $msfi = glob($cachenewsfile."news*.php");
		        if ($msfi) foreach ($msfi as $filen) {
		            if (file_exists($filen)) {
		            	unlink($filen);
		            }
		        }
		    }
		    
		    // Delete the rates
		    if (!empty($defaults['jak_delete_rate'])) {
		    	$jakdb->query('UPDATE '.$jaktable.' SET voteup = 0, votedown = 0 WHERE id = '.$page2);
		    }
		    
		    // Delete the hits
		    if (!empty($defaults['jak_delete_hits'])) {
		    	$jakdb->query('UPDATE '.$jaktable.' SET hits = 1 WHERE id = '.$page2);
		    }
	
		    if (empty($defaults['jak_title'])) {
		        $errors['e1'] = $tl['error']['e2'];
		    }
		    
		    if (!empty($defaults['jak_datefrom'])) {
		    
		    	list($yearf, $monthf, $dayf) = explode('-', $defaults['jak_datefrom']);
		    	$finalfrom = mktime($defaults['jak_timefrom'], $defaults['jak_timefromm'], 0, $monthf, $dayf, $yearf);
		    	
		    }
		    
		    if (!empty($defaults['jak_dateto'])) {
		    		
		    	list($yeart, $montht, $dayt) = explode('-', $defaults['jak_dateto']);
		    	$finalto = mktime($defaults['jak_timeto'], $defaults['jak_timetom'], 0, $montht, $dayt, $yeart);
		    	
		    }
		    
		    if (isset($finalto) && isset($finalfrom) && $finalto < $finalfrom) {
		    	$errors['e2'] = $tl['error']['e28'];
		    }
		    
		    // Now do the dirty stuff in mysql       
		    if (count($errors) == 0) {
		    
		    if (empty($defaults['jak_img'])) $defaults['jak_img'] = '';
		    
		    // Update time
		    if (!empty($defaults['jak_update_time'])) {
		    	$insert .= 'time = NOW(),';
		    }
		    
		    // save the time if available
		    if (isset($finalfrom)) {
		    	$insert .= 'startdate = "'.$finalfrom.'",';
		    }
		    
		    if (isset($finalto)) {
		    	$insert .= 'enddate = "'.$finalto.'",';
		    }
		    
		    if (!isset($defaults['jak_permission'])) {
		    	$permission = 0;
		    } else {
		    	$permission = join(',', $defaults['jak_permission']);
		    }
		    
		    // Get the php hook for display stuff in pages
		    $hooknews = $jakhooks->jakGethook("php_admin_news_sql");
		    if ($hooknews) {
		    foreach($hooknews as $hne)
		    {
		    	eval($hne['phpcode']);
		    }
		    }
		
			$result = $jakdb->query('UPDATE '.$jaktable.' SET 
			title = "'.smartsql($defaults['jak_title']).'",
			title_l2 = "'.smartsql($defaults['jak_title2']).'",
			title_l3 = "'.smartsql($defaults['jak_title3']).'",
			content = "'.smartsql($defaults['jak_content']).'",
			content_l2 = "'.smartsql($defaults['jak_content2']).'",
			content_l3 = "'.smartsql($defaults['jak_content3']).'",
			news_css = "'.smartsql($defaults['jak_css']).'",
			news_javascript = "'.smartsql($defaults['jak_javascript']).'",
			sidebar = "'.smartsql($defaults['jak_sidebar']).'",
			previmg = "'.$defaults['jak_img'].'",
			showtitle = "'.$defaults['jak_showtitle'].'",
			showcontact = "'.$defaults['jak_showcontact'].'",
			showdate = "'.$defaults['jak_showdate'].'",
			socialbutton = "'.$defaults['jak_social'].'",
			'.$insert.'
			permission = "'.$permission.'",
			showvote = "'.$defaults['jak_vote'].'"
			WHERE id = "'.smartsql($page2).'"');
			
			// Insert new stuff first if exist order for extra stuff
			if ($defaults['real_plugin_id']) {
				$exorder = $defaults['corder_new'];
				$pluginid = $defaults['real_plugin_id'];
				$doit = array_combine($pluginid, $exorder);
				
				foreach ($doit as $key => $exorder) {
				
					$jakdb->query('INSERT INTO '.$jaktable2.' SET newsid = "'.$page2.'", pluginid = "'.$key.'", orderid = "'.$exorder.'"');
				
				}
			
			}
			
			// Save order for sidebar widget
			if (is_array($defaults['jak_hookshow_new'])) {
			
				$exorder = $defaults['horder_new'];
				$hookid = $defaults['real_hook_id_new'];
				$plugind = $defaults['sreal_plugin_id_new'];
				$doith = array_combine($hookid, $exorder);
				$pdoith = array_combine($hookid, $plugind);
				
				foreach ($doith as $key => $exorder) {
				
					if (in_array($key, $defaults['jak_hookshow_new'])) {
					
						// Get the real what id
						$whatid = $defaults['whatid_'.$pdoith[$key]];	
						
						if (!$whatid) $whatid = 0;
						
						$jakdb->query('INSERT INTO '.$jaktable2.' SET newsid = "'.$page2.'", hookid = "'.$key.'", pluginid = "'.$pdoith[$key].'", whatid = "'.$whatid.'", orderid = "'.$exorder.'"');
					
					}
				
				}
			
			}
			
			// Save order for extra stuff
			$exorder = $defaults['corder'];
			$pluginid = $defaults['real_id'];
			$realid = implode(',', $defaults['real_id']);
			$doit = array_combine($pluginid, $exorder);
			
			foreach ($doit as $key => $exorder) {
				$updatesql .= sprintf("WHEN %d THEN %d ", $key, $exorder);
			}
			
			$jakdb->query('UPDATE '.$jaktable2.' SET orderid = CASE id
			'.$updatesql.'
			END
			WHERE id IN ('.$realid.')');
			
			// Now check if all the sidebar a deselct and hooks exist, if so delete all associated to this page
			$result = $jakdb->query('SELECT id FROM '.$jaktable2.' WHERE newsid = "'.smartsql($page2).'" AND hookid != 0');
				$row = $result->fetch_assoc();
			
			if (!is_array($defaults['jak_hookshow_new']) && $row['id'] && !is_array($defaults['jak_hookshow'])) {
			
				$jakdb->query('DELETE FROM '.$jaktable2.' WHERE newsid = "'.smartsql($page2).'" AND hookid != 0');
			
			}
			
			// Save order or delete for extra sidebar widget
			if (is_array($defaults['jak_hookshow'])) {
			
				$exorder = $defaults['horder'];
				$hookid = $defaults['real_hook_id'];
				$hookrealid = implode(',', $defaults['real_hook_id']);
				$doith = array_combine($hookid, $exorder);
				
				foreach ($doith as $key => $exorder) {
					
					// Get the real what id
					$result = $jakdb->query('SELECT pluginid FROM '.$jaktable2.' WHERE id = "'.smartsql($key).'" AND hookid != 0');
					$row = $result->fetch_assoc();
						
					$whatid = $defaults['whatid_'.$row["pluginid"]];
						
					if (!$whatid) $whatid = 0;
						
						if (in_array($key, $defaults['jak_hookshow'])) {
							$updatesql .= sprintf("WHEN %d THEN %d ", $key, $exorder);
							$updatesql1 .= sprintf("WHEN %d THEN %d ", $key, $whatid);
							
						} else {
							$jakdb->query('DELETE FROM '.$jaktable2.' WHERE id = '.$key.'');
						}
					}
					
					$jakdb->query('UPDATE '.$jaktable2.' SET orderid = CASE id
					'.$updatesql.'
					END
					WHERE id IN ('.$hookrealid.')');
					
					$jakdb->query('UPDATE '.$jaktable2.' SET whatid = CASE id
					'.$updatesql1.'
					END
					WHERE id IN ('.$hookrealid.')');
			
			}
	
			if (!$result) {
	    		jak_redirect(BASE_URL.'index.php?p=news&sp=edit&ssp='.$page2.'&sssp=e');
			} else {
			
			// Set tag active to zero
			$tagactive = 0;
			
			if ($defaults['jak_active'] != 0) {
				
				// Set tag active, well to active
				$tagactive = 1;
				
			}
		
			// Create Tags if the module is active
			if (!empty($defaults['jak_tags'])) {
				// check if tag does not exist and insert in cloud
		        JAK_tags::jakBuildcloud($defaults['jak_tags'], smartsql($page2), 1);
		        // insert tag for normal use
		        JAK_tags::jakInsertags($defaults['jak_tags'], smartsql($page2), 1, $tagactive);
		        
		        // Now let us delete the tag cache file
		        $cachetagfile = '../'.JAK_CACHE_DIRECTORY.'/tags.php';
		        if (file_exists($cachetagfile)) {
		        	unlink($cachetagfile);
		        }
			}
			
			// Now let us delete the news cache file
			$cachenewsfile = '../'.JAK_CACHE_DIRECTORY.'/';
			$msfi = glob($cachenewsfile."news*.php");
			if ($msfi) foreach ($msfi as $filen) {
			    if (file_exists($filen)) {
			    	unlink($filen);
			    }
			}
			
	        	jak_redirect(BASE_URL.'index.php?p=news&sp=edit&ssp='.$page2.'&sssp=s');
	    	}
	 		} else {
	    
		   	$errors['e'] = $tl['error']['e'];
		    $errors = $errors;
		    }
			}
	
			$JAK_FORM_DATA = jak_get_data($page2,$jaktable);
			if (JAK_TAGS) $JAK_TAGLIST = jak_get_tags($page2, 1);
			
			// Get the sort orders for the grid
			$grid = $jakdb->query('SELECT id, pluginid, hookid, whatid, orderid FROM '.$jaktable2.' WHERE newsid = "'.smartsql($page2).'" ORDER BY orderid ASC');
			while ($grow = $grid->fetch_assoc()) {
			        // collect each record into $_data
			        $pagegrid[] = $grow;
			}
			
			$JAK_PAGE_GRID = $pagegrid;
			
			// Get the sidebar templates
			$result = $jakdb->query('SELECT id, name, widgetcode, exorder, pluginid FROM '.$jaktable3.' WHERE hook_name = "tpl_sidebar" AND active = 1 ORDER BY exorder ASC');
			while ($row = $result->fetch_assoc()) {
				$plhooks[] = $row;
			}
			// Get all plugins out the databse
			$JAK_HOOKS = $plhooks;
			
			// Get the php hook for display stuff in pages
			$hookpagei = $jakhooks->jakGethook("php_admin_pages_news_info");
			if ($hookpagei) { foreach($hookpagei as $hpagi)
			{
				eval($hpagi['phpcode']);
			}
			}
			
			// Get all usergroup's
			$JAK_USERGROUP = jak_get_usergroup_all('usergroup');
			
			$template = 'editnews.php';
			
			} else {
			   	jak_redirect(BASE_URL.'index.php?p=news&sp=ene');
			}
		break;
		default:
			
			// Get total news
			$getTotal = jak_get_total($jaktable,'','','');
			if ($getTotal != 0) {
			
				// Paginator
				$pages = new Paginator;
				$pages->items_total = $getTotal;
				$pages->mid_range = JAK_ADMINPAGEMID;
				$pages->items_per_page = JAK_ADMINPAGEITEM;
				$pages->jak_get_page = $page1;
				$pages->jak_where = 'index.php?p=news';
				$pages->paginate();
				$JAK_PAGINATE = $pages->display_pages();
			}
			
			// Call the news with paginate
			$JAK_NEWS = jak_get_news_info($pages->limit);
			    
			// Call the template
			$template = 'news.php';
		}
}
?>