<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

// Check if the file is accessed only via index.php if not stop the script from running
if (!defined('JAK_ADMIN_PREVENT_ACCESS')) die('You cannot access this file directly.');

// Check if the user has access to this file
if (!JAK_ADMINACCESS || !$JAK_MODULES) jak_redirect(BASE_URL);

// All the tables we need for this plugin
$errors = array();

// Important DB Tables
$jaktable = DB_PREFIX.'categories';
$jaktable1 = DB_PREFIX.'clickstat';

// Important template Stuff
$JAK_SETTING = jak_get_setting('setting');

// Get the php hook for setting top before language control
$getsettinghook = $jakhooks->jakGethook("php_admin_setting");
if ($getsettinghook) foreach($getsettinghook as $sh)
{
	eval($sh['phpcode']);
}

// Call the hooks per name for setting template
$JAK_HOOK_ADMIN_SETTING_EDIT = $jakhooks->jakGethook("tpl_admin_setting");

if ($page1 == "trunheat") {

	$result = $jakdb->query('TRUNCATE '.$jaktable1);
		
	jak_redirect(BASE_URL.'index.php?p=setting&sp=s');

}

// Let's go on with the script
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    $defaults = $_POST;
    
    // Get the php hook for setting top before language control
    $getsettingpost = $jakhooks->jakGethook("php_admin_setting_post");
    if ($getsettingpost) foreach($getsettingpost as $shp)
    {
    	eval($shp['phpcode']);
    }
    
    if ($defaults['jak_email'] == '' || !filter_var($defaults['jak_email'], FILTER_VALIDATE_EMAIL)) { 
    	$errors['e1'] = $tl['error']['e3'];
    }
    
    if ($defaults['jak_lang'] == '') { $errors['e6'] = $tl['error']['e29']; }

    if (empty($defaults['jak_date'])) { $errors['e2'] = $tl['error']['e4']; }
    
    if (!is_numeric($defaults['jak_shortmsg'])) { $errors['e3'] = $tl['error']['e15']; }
    
    if (!is_numeric($defaults['jak_item'])) { $errors['e4'] = $tl['error']['e15']; }
    
    if (!is_numeric($defaults['jak_mid'])) { $errors['e4'] = $tl['error']['e15']; }
    
    if (!is_numeric($defaults['jak_rssitem'])) { $errors['e5'] = $tl['error']['e15']; }
    
    if (!is_numeric($defaults['jak_avatwidth']) || !is_numeric($defaults['jak_avatheight'])) { $errors['e7'] = $tl['error']['e15']; }

    if (count($errors) == 0) {
    
    // Do the dirty work in mysql
    
    $result = $jakdb->query('UPDATE '.DB_PREFIX.'setting SET value = CASE varname
        WHEN "email" THEN "'.smartsql($defaults['jak_email']).'"
        WHEN "sitehttps" THEN '.$defaults['jak_shttp'].'
        WHEN "lang" THEN "'.smartsql($defaults['jak_lang']).'"
        WHEN "lang2" THEN "'.smartsql($defaults['jak_lang2']).'"
        WHEN "lang3" THEN "'.smartsql($defaults['jak_lang3']).'"
        WHEN "langdirection" THEN "'.smartsql($defaults['jak_langd']).'"
        WHEN "langdirection2" THEN "'.smartsql($defaults['jak_langd2']).'"
        WHEN "langdirection3" THEN "'.smartsql($defaults['jak_langd3']).'"
        WHEN "multilang" THEN '.$defaults['jak_multilang'].'
        WHEN "showloginside" THEN '.$defaults['jak_loginside'].'
        WHEN "useravatwidth" THEN "'.smartsql($defaults['jak_avatwidth']).'"
        WHEN "useravatheight" THEN "'.smartsql($defaults['jak_avatheight']).'"
        WHEN "printme" THEN '.$defaults['jak_sprint'].'
        WHEN "shortmsg" THEN "'.smartsql($defaults['jak_shortmsg']).'"
        WHEN "dateformat" THEN "'.smartsql($defaults['jak_date']).'"
        WHEN "timeformat" THEN "'.smartsql($defaults['jak_time']).'"
        WHEN "adv_editor" THEN "'.smartsql($defaults['jak_editor']).'"
        WHEN "usr_smilies" THEN "'.smartsql($defaults['jak_smilies']).'"
        WHEN "timezoneserver" THEN "'.$defaults['jak_timezone_server'].'"
        WHEN "searchform" THEN '.$defaults['jak_search'].'
        WHEN "ajaxsearch" THEN '.$defaults['jak_ajaxsearch'].'
        WHEN "fulltextsearch" THEN '.$defaults['jak_fullsearch'].'
        WHEN "contactform" THEN '.$defaults['jak_contact'].'
        WHEN "shownews" THEN '.$defaults['jak_shownews'].'
        WHEN "rss" THEN '.$defaults['jak_rss'].'
        WHEN "rssitem" THEN "'.smartsql($defaults['jak_rssitem']).'"
        WHEN "adminpagemid" THEN "'.smartsql($defaults['jak_mid']).'"
        WHEN "adminpageitem" THEN "'.smartsql($defaults['jak_item']).'"
        WHEN "ip_block" THEN "'.smartsql($defaults['ip_block']).'"
        WHEN "email_block" THEN "'.smartsql($defaults['email_block']).'"
        WHEN "analytics" THEN "'.smartsql($defaults['jak_analytics']).'"
        WHEN "heatmap" THEN '.$defaults['jak_heatmap'].'
    END
		WHERE varname IN ("email","sitehttps","lang","lang2","lang3","langdirection","langdirection2","langdirection3","multilang","showloginside","loginside","useravatwidth","useravatheight","userpath","printme","shortmsg","dateformat","timeformat","timezoneserver","adv_editor","usr_smilies","searchform","ajaxsearch","fulltextsearch","contactform","shownews","rss","rssitem","adminpagemid","adminpageitem","ip_block","email_block","analytics","heatmap")');
		
	// Now let us delete the define cache file
	$cachedefinefile = '../'.JAK_CACHE_DIRECTORY.'/define.php';
	if (file_exists($cachedefinefile)) {
		unlink($cachedefinefile);
	}
	
	// Now change the mysql full text search if whish so
	if ($defaults['jak_fullsearch'] != $defaults['jak_fullsearchold']) {
		
		// mysql fulltext search is needed
		if ($defaults['jak_fullsearch']) {
			
			// SQL Queries
			$jakdb->query('ALTER TABLE '.DB_PREFIX.'pages ADD FULLTEXT(`title`, `content`)');
			$jakdb->query('ALTER TABLE '.DB_PREFIX.'news ADD FULLTEXT(`title`, `content`)');
			
			// Get the php hook full text queries
			$mft = $jakhooks->jakGethook("php_admin_fulltext_add");
			if ($mft) foreach($mft as $m)
			{
				eval($m['phpcode']);
			}
			
		} else {
		
			// SQL Queries
			$jakdb->query('ALTER TABLE '.DB_PREFIX.'pages DROP INDEX `title`');
			$jakdb->query('ALTER TABLE '.DB_PREFIX.'news DROP INDEX `title`');
		
			// Get the php hook full text queries
			$mftr = $jakhooks->jakGethook("php_admin_fulltext_remove");
			if ($mftr) foreach($mftr as $mr)
			{
				eval($mr['phpcode']);
			}
			
		}
	}
		
	if (!$result) {
		jak_redirect(BASE_URL.'index.php?p=setting&sp=e');
	} else {		
        jak_redirect(BASE_URL.'index.php?p=setting&sp=s');
    }
    } else {
    
   	$errors['e'] = $tl['error']['e'];
    $errors = $errors;
    }
}

// Call the settings function
$acp_lang_files = jak_get_lang_files(true);
$lang_files = jak_get_lang_files(false);
// Call the template
$template = 'setting.php';
?>