<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

// Check if the file is accessed only via index.php if not stop the script from running
if (!defined('JAK_ADMIN_PREVENT_ACCESS')) die('You cannot access this file directly.');

// Check if the user has access to this file
if (!JAK_ADMINACCESS || !$jakuser->jakModuleaccess(JAK_USERID_CMS, JAK_ACCESSTAGS)) jak_redirect(BASE_URL);

// All the tables we need for this plugin
$errors = array(); // put the error in a array
$jaktable = DB_PREFIX.'tags';
$jaktable1 = DB_PREFIX.'tagcloud';
$jaktable2 = DB_PREFIX.'pagesgrid';
$jaktable3 = DB_PREFIX.'pluginhooks';

// Now start with the plugin use a switch to access all pages
switch ($page1) {

	// Get the tag cloud
	case 'cloud':
	
		// Important template Stuff
		$JAK_TAGCLOUD = jak_admin_tag_cloud();
		
		switch ($page2) {
		    case 'delete':
		        if (jak_field_not_exist($page3,$jaktable1,'tag')) {
		        	
		        		global $jakdb;
		        	    $sql = 'DELETE FROM '.$jaktable1.' WHERE tag = "'.smartsql($page3).'"';
		        	    $result = $jakdb->query($sql);
		        	       
		        	    $sql1 = 'DELETE FROM '.$jaktable.' WHERE tag = "'.smartsql($page3).'"';
		        	    $result1 = $jakdb->query($sql1);
		        	    
		        	    // Now let us delete the tag cache file
		        	    $cachetagfile = '../'.JAK_CACHE_DIRECTORY.'/tags.php';
		        	    if (file_exists($cachetagfile)) {
		        	    	unlink($cachetagfile);
		        	    }
		        			
		        if (!$result || !$result1) {
		            	jak_redirect(BASE_URL.'index.php?p=tags&sp=cloud&ssp=e');
		        	} else {
		                jak_redirect(BASE_URL.'index.php?p=tags&sp=cloud&ssp=s');
		            }
		        
		    
		} else {
		   	jak_redirect(BASE_URL.'index.php?p=tags&sp=cloud&ssp=ene');
		}
		break;
		default:
			define(TAG_DELETE_CLOUD, $tl['tag']['al']);
			// Call the template
			$template = 'tagcloud.php';
		}
		
	break;
	case 'setting':
	
		// Important template Stuff
		$JAK_SETTING = jak_get_setting('tags');
		
		// Let's go on with the script
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		    $defaults = $_POST;
		    
		    if (!is_numeric($defaults['jak_limit'])) {
		        $errors['e1'] = $tl['error']['e15'];
		    }
		    
		    if (!is_numeric($defaults['jak_min'])) {
		        $errors['e2'] = $tl['error']['e15'];
		    }
		    
		    if (!is_numeric($defaults['jak_max'])) {
		        $errors['e3'] = $tl['error']['e15'];
		    }
		
		    if (count($errors) == 0) {
		    
		    // Do the dirty work in mysql
		    
		    $sql = 'UPDATE '.DB_PREFIX.'setting SET value = CASE varname
		    	WHEN "tagtitle" THEN "'.smartsql($defaults['jak_title']).'"
		    	WHEN "tagdesc" THEN "'.smartsql($defaults['jak_description']).'"
		    	WHEN "taglimit" THEN "'.smartsql($defaults['jak_limit']).'"
		        WHEN "tagminfont" THEN "'.smartsql($defaults['jak_min']).'"
		        WHEN "tagmaxfont" THEN "'.smartsql($defaults['jak_max']).'"        
		    END
				WHERE varname IN ("tagtitle", "tagdesc", "taglimit", "tagminfont", "tagmaxfont")';
				$result = $jakdb->query($sql);
				
			// Save order for sidebar widget
			if (is_array($defaults['jak_hookshow_new'])) {
			
				$exorder = $defaults['horder_new'];
				$hookid = $defaults['real_hook_id_new'];
				$plugind = $defaults['sreal_plugin_id_new'];
				$doith = array_combine($hookid, $exorder);
				$pdoith = array_combine($hookid, $plugind);
				
				foreach ($doith as $key => $exorder) {
				
					if (in_array($key, $defaults['jak_hookshow_new'])) {
					
						// Get the real what id
						$whatid = $defaults['whatid_'.$pdoith[$key]];
								
						if (!$whatid) $whatid = 0;
				
						$jakdb->query('INSERT INTO '.$jaktable2.' SET plugin = 3, hookid = "'.$key.'", pluginid = "'.$pdoith[$key].'", whatid = "'.$whatid.'", orderid = "'.$exorder.'"');
					
					}
				
				}
			
			}
			
			// Now check if all the sidebar a deselct and hooks exist, if so delete all associated to this page
			$result = $jakdb->query('SELECT id FROM '.$jaktable2.' WHERE plugin = 3 AND hookid != 0');
				$row = $result->fetch_assoc();
			
			if (!is_array($defaults['jak_hookshow_new']) && $row['id'] && !is_array($defaults['jak_hookshow'])) {
			
				$jakdb->query('DELETE FROM '.$jaktable2.' WHERE plugin = 3 AND hookid != 0');
			
			}
				
			// Save order or delete for extra sidebar widget
			if (is_array($defaults['jak_hookshow'])) {
			
				$exorder = $defaults['horder'];
				$hookid = $defaults['real_hook_id'];
				$hookrealid = implode(',', $defaults['real_hook_id']);
				$doith = array_combine($hookid, $exorder);
				
				foreach ($doith as $key => $exorder) {
					
					// Get the real what id
					$result = $jakdb->query('SELECT pluginid FROM '.$jaktable2.' WHERE id = "'.smartsql($key).'" AND hookid != 0');
					$row = $result->fetch_assoc();
						
					$whatid = $defaults['whatid_'.$row["pluginid"]];
						
					if (!$whatid) $whatid = 0;
						
					if (in_array($key, $defaults['jak_hookshow'])) {
						$updatesql .= sprintf("WHEN %d THEN %d ", $key, $exorder);
						$updatesql1 .= sprintf("WHEN %d THEN %d ", $key, $whatid);
							
					} else {
						$jakdb->query('DELETE FROM '.$jaktable2.' WHERE id = '.$key);
					}
				}
					
				$jakdb->query('UPDATE '.$jaktable2.' SET orderid = CASE id
					'.$updatesql.'
					END
					WHERE id IN ('.$hookrealid.')');
					
				$jakdb->query('UPDATE '.$jaktable2.' SET whatid = CASE id
					'.$updatesql1.'
					END
					WHERE id IN ('.$hookrealid.')');
			
			}
			
			// Now let us delete the define cache file
			$cachedefinefile = '../'.JAK_CACHE_DIRECTORY.'/define.php';
			if (file_exists($cachedefinefile)) {
				unlink($cachedefinefile);
			}
			
			// Now let us delete the tag cache file
			$cachetagfile = '../'.JAK_CACHE_DIRECTORY.'/tags.php';
			if (file_exists($cachetagfile)) {
				unlink($cachetagfile);
			}
				
			if (!$result) {
				jak_redirect(BASE_URL.'index.php?p=tags&sp=setting&ssp=e');
			} else {
		        jak_redirect(BASE_URL.'index.php?p=tags&sp=setting&ssp=s');
		    }
		    } else {
		    
		   	$errors['e'] = $tl['error']['e'];
		    $errors = $errors;
		    }
		}
		
		// Get the sort orders for the grid
		$grid = $jakdb->query('SELECT id, hookid, whatid, orderid FROM '.$jaktable2.' WHERE plugin = 3 ORDER BY orderid ASC');
		while ($grow = $grid->fetch_assoc()) {
		        // collect each record into $_data
		        $pagegrid[] = $grow;
		}
		
		$JAK_PAGE_GRID = $pagegrid;
		
		
		// Get the sidebar templates
		$result = $jakdb->query('SELECT id, name, widgetcode, exorder, pluginid FROM '.$jaktable3.' WHERE hook_name = "tpl_sidebar" AND active = 1 ORDER BY exorder ASC');
		while ($row = $result->fetch_assoc()) {
			$plhooks[] = $row;
		}
		// Get all plugins out the databse
		$JAK_HOOKS = $plhooks;
		
		// Get the php hook for display stuff in pages
		$hookpagei = $jakhooks->jakGethook("php_admin_pages_news_info");
		if ($hookpagei) { foreach($hookpagei as $hpagi)
		{
			eval($hpagi['phpcode']);
		}
		}
		
		// Call the template
		$template = 'tagsetting.php';
		
	break;
	default:
		
		// Let's go on with the script
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		    $defaults = $_POST;
		    
		    if (isset($defaults['delete'])) {
		    
		    $tags = $defaults['jak_delete_tag'];
		
		        for ($i = 0; $i < count($tags); $i++) {
		            $tag = $tags[$i];
		            
					JAK_tags::jakDeleteonetag($tag);	
		        }
				
		        jak_redirect(BASE_URL.'index.php?p=tags&sp=s');
		    
		    }
		 }
		 
		switch ($page1) {
		 case 'sort':
		  		if ($page2 == 'pluginid') {
		 			$bu = 'pluginid';
		 		} else {
		 			jak_redirect(BASE_URL);
		 		}
		 		$getTotal = jak_get_total($jaktable,$page3,$bu,'');
		 		if ($getTotal != 0) {
		 		// Paginator
		 			$pages = new Paginator;
		 			$pages->items_total = $getTotal;
		 			$pages->mid_range = JAK_ADMINPAGEMID;
		 			$pages->items_per_page = JAK_ADMINPAGEITEM;
		 			$pages->jak_get_page = $page4;
		 			$pages->jak_where = 'tag/sort/'.$page2.'/'.$page3.'/';
		 			$pages->paginate();
		 			$JAK_PAGINATE_SORT = $pages->display_pages();
		        	$JAK_TAG_ALL = jak_get_tag($pages->limit,$page3,$jakplugins->jakAdmintag());
		        // Get the template, same from the pm but modified... :)
		        $template = 'tag.php';
		        } else {
		        	jak_redirect(BASE_URL.'index.php?p=tags');
		        }
		break;
		case 'delete':
		    if (jak_row_exist($page2,$jaktable)) {
		        	
		    	JAK_tags::jakDeleteonetag($page2);
		    	
		    	// Now let us delete the tag cache file
		    	$cachetagfile = '../'.JAK_CACHE_DIRECTORY.'/tags.php';
		    	if (file_exists($cachetagfile)) {
		    		unlink($cachetagfile);
		    	}
		        			
		        jak_redirect(BASE_URL.'index.php?p=tags&sp=s');
		    
			} else {
			   	jak_redirect(BASE_URL.'index.php?p=tags&sp=ene');
			}
		break;
		default:
			
			// Important template Stuff
			$getTotal = jak_get_total($jaktable,'','','');
			if ($getTotal != 0) {
			// Paginator
				$pages = new Paginator;
				$pages->items_total = $getTotal;
				$pages->mid_range = JAK_ADMINPAGEMID;
				$pages->items_per_page = JAK_ADMINPAGEITEM;
				$pages->jak_get_page = $page1;
				$pages->jak_where = 'index.php?p=tags';
				$pages->paginate();
				$JAK_PAGINATE = $pages->display_pages();
				}
			$JAK_TAG_ALL = jak_get_tag($pages->limit,'',$jakplugins->jakAdmintag());
			 
			// Call the template
			$template = 'tag.php';
		}
}
?>