<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

class JAK_comment
{
	private $data = array();
	
	// Get the lang into the class
	
	public function __construct($table, $where, $id, $var, $ptime, $pdate)
	{
		/*
		/	The constructor
		*/
		
		global $jakdb;
		
		$result = $jakdb->query('SELECT t1.id, t1.userid, t1.username, t1.email, t1.web, t1.message, t1.session, t1.time, t2.picture, t2.lastactivity, t2.usergroupid FROM '.$table.' AS t1 LEFT JOIN '.DB_PREFIX.'user AS t2 ON (t2.id = t1.userid) WHERE t1.'.$where.' = "'.smartsql($id).'" AND ((t1.approve = 1 AND t1.trash = 0) OR (t1.approve = 0 AND t1.trash = 0 AND t1.session = "'.session_id().'")) ORDER BY time ASC');
		
		while ($row = $result->fetch_assoc()) {
				
				$getTime = JAK_base::jakTimesince($row['time'], $ptime, $pdate);
				
				if (strtotime($row['lastactivity']) >= (time() - 1800)) {
					$uiso = 1;
				} else {
					$uiso = 0;
				}
				
				// See if the user is a admin or mod
				if ($row['usergroupid'] == 3) {
					
					// The user is in this group
					$isam = 1;
				} elseif ($row['usergroupid'] == 4) {
				
					$isam = 2;
				} else {
				
					$isam = 0;
				}
				
				if (!empty($row['web'])) {
					$row['username'] = '<a href="'.$row['web'].'">'.$row['username'].'</a>';
				} else {
					$row['username'] = $row['username'];
				}
				
				// There should be always a varname in categories and check if seo is valid
				$parseurl1 = JAK_rewrite::jakParseurl($var, 'del', $row['id'], $row['userid'], '');
				$parseurl2 = JAK_rewrite::jakParseurl($var, 'ep', $row['id'], $id, '');
				$parseurl3 = JAK_rewrite::jakParseurl($var, 'trash', $row['id'], $id, '');
				
		        // collect each record into $jakdata
		        $jakdata[] = array('id' => $row['id'], 'userid' => $row['userid'], 'username' => $row['username'], 'parseurl1' => $parseurl1, 'parseurl2' => $parseurl2, 'parseurl3' => $parseurl3, 'email' => $row['email'], 'web' => $row['web'], 'message' => jak_secure_site($row['message']), 'session' => $row['session'], 'created' => $getTime, 'created_html5' => date("Y-m-d", strtotime($row['time'])), 'picture' => $row['picture'], 'uonstat' => $uiso, 'isam' => $isam, 'picture' => $row['picture']);
		        
		    }
		
		$this->data = $jakdata;
	}
	
	public function get_comments()
	{
		
		// Setting up an alias, so we don't have to write $this->data every time:
		$d = &$this->data;
		
		return $d;
		
	}
	
	public function get_commentajax($lang, $lang1, $lang2) {
		
		foreach($this->data as $d) {
		
		if ($d['userid'] && $d['picture']) {
			
			$avatar = '<img src="'.BASE_URL.JAK_USER_DIRECTORY.$d['picture'].'" alt="avatar" />';
		} else {
			
			$avatar = '<img src="'.BASE_URL.JAK_USER_DIRECTORY.'/standard.png" alt="avatar" />';
		}
		
		if ($d['session']) {
			$approve = ' <div class="alert alert-info">'.$lang2.'</div> ';
		}
		
		return '<div class="row"><div class="span2">'.$avatar.'</div><div class="span7"><h4>'.str_replace("%s", $link_open.$d['username'].$link_close, $lang).'</h4>'.$approve.''.stripslashes($d['message']).'</div></div><hr>';
		
		}
	
	}
	
	public function get_total() {
		// Setting up an alias, so we don't have to write $this->data every time:
		$d = $this->data;
		
		if ($d) {
		
			foreach($d as $t)
			{
				$total[] = $t['id'];
			}
		
			// get the total user in one var.
			$total = count($total, COUNT_RECURSIVE);
		
		} else {
		
			$total = 0;
		
		}
		
		return $total;
	}
	
	public static function validate_form(&$arr, $maxpost, $ename, $eemail, $eurl, $epost, $emaxpost, $emaxpost1, $ehuman)
	{
		/*
		/	This method is used to validate the data sent via AJAX.
		/
		/	It return true/false depending on whether the data is valid, and populates
		/	the $arr array passed as a paremter (notice the ampersand above) with
		/	either the valid input data, or the error messages.
		*/
		
		$errors = array();
		$data	= array();
		
		// Using the filter with a custom callback function:
		if(!($data['co_name'] = filter_input(INPUT_POST, 'co_name', FILTER_CALLBACK, array('options'=>'JAK_comment::validate_text'))))
		{
			$errors['co_name'] = $ename.'<br />';
		}
		
		if (!JAK_USERID_CMS) {
		if (!($data['co_email'] = filter_input(INPUT_POST, 'co_email', FILTER_VALIDATE_EMAIL))) {
		    $errors['co_email'] = $eemail.'<br />';
		}
		
		if (filter_input(INPUT_POST , 'co_url')) {
		   if (!($data['co_url'] = filter_input(INPUT_POST, 'co_url', FILTER_VALIDATE_URL))) {
		       $errors['co_url'] = $eurl.'<br />';
		   }
		}
		}
		
		// Using the filter with a custom callback function:
		if(!($data['userpost'] = filter_input(INPUT_POST, 'userpost', FILTER_CALLBACK, array('options'=>'JAK_comment::validate_text'))))
		{
			$errors['userpost'] = $epost.'<br />';
		}
		
		// Count comment charactars
		$countI = strlen($data['userpost']);
		
		if ($countI > $maxpost) {
		    $errors['userpost'] = $emaxpost.$maxpost.' '.$emaxpost1.$countI;
		}
		
		if (!JAK_USERID_CMS) {
		if (JAK_HVM == 1) {
		
			$humanhidden = filter_input(INPUT_POST, 'humanhidden', FILTER_SANITIZE_STRING);
			$humanid = filter_input(INPUT_POST, 'humanid', FILTER_SANITIZE_STRING);
			$human = filter_input(INPUT_POST, 'co_human'.$humanhidden.'', FILTER_SANITIZE_STRING);
			
				if (!$human || !jak_validate_spam($human, $humanid)) {
			    	$errors['co_human'] = $ehuman.'<br />';
				}
		
		} elseif (JAK_HVM == 2) {
		
			$human = filter_input(INPUT_POST, 'co_human', FILTER_SANITIZE_STRING);
		
			if (!$human || (md5($human) != $_SESSION['JAK_HUMAN_IMAGE'])) {
		    	$errors['co_human'] = $ehuman.'<br />';
			}
		}
		}
		
		if(!empty($errors)){
			
			// If there are errors, copy the $errors array to $arr:
			
			$arr = $errors;
			return false;
		}
		
		// If the data is valid, sanitize all the data and copy it to $arr:
		
		foreach($data as $k=>$v){
			$arr[$k] = smartsql($v);
		}
		
		// Ensure that the email is lower case:
		
		$arr['co_email'] = strtolower(trim($arr['co_email']));
		
		return true;
		
	}

	private static function validate_text($str)
	{
		/*
		/	This method is used internally as a FILTER_CALLBACK
		*/
		
		if(mb_strlen($str, 'utf8') < 1)
			return false;
			
		$str = nl2br(htmlspecialchars($str));
		
		// Remove the new line characters that are left
		$str = str_replace(array(chr(10), chr(13)), '', $str); 
		
		return $str;
	}

}
?>