<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

include_once 'class.rewrite.php';

class JAK_base
{
	private $data = array();
	private $usraccesspl = array();
	private $case;
	private $jakvar;
	private $jakvar1;
	protected $table = '', $itemid = '', $select = '', $where = '', $dseo = '';
	
	// This constructor can be used for all classes:
	
	public function __construct(array $options){
			
			foreach($options as $k=>$v){
				if(isset($this->$k)){
					$this->$k = $v;
				}
			}
	}
	
	public static function jakCleanurl($jakvar)
	{
	
		$jakvar = strip_tags($jakvar);
		$jakvar = strtolower($jakvar);
		$crepl = array(' ','.','(',')',"'","?","!","/","*","+","&","%","=","$",":",",",";","<",">","ä","ö","ü","Ä","Ü","Ö","é","à","è","ô",'"','---','--','#');
		$cfin = array('-','','','','-','','','','','','','','','','','','','','','au','oe','ue','au','ue','oe','e','a','e','o','','-','-','');
		$jakvar = str_replace($crepl, $cfin, $jakvar);	
		return $jakvar;
	
	}
	
	public static function jakunCleanurl($jakvar)
	{
	
		$jakvar = strip_tags($jakvar);
		$jakvar = strtolower($jakvar);
		$crepl = array("ä","ö","ü","Ä","Ü","Ö","é","à","è","ô");
		$cfin = array('au','oe','ue','au','oe','ue','e','a','e','o');
		$jakvar = str_replace($cfin, $crepl, $jakvar);	
		return $jakvar;
	
	}
	
	public static function jakTimesince($mysqlstamp, $date, $time)
	{
	
		$today = time(); /* Current unix time  */
		$mysqlstamp = strtotime($mysqlstamp);
		$since = $today - $mysqlstamp;
		
		if ($since < 129600) {
		
		// array of time period chunks
		    $chunks = array(
		        array(60 * 60 * 24 , JAK_DAY),
		        array(60 * 60 , JAK_HOUR),
		        array(60 , JAK_MINUTE),
		    );
		
		    $today = time(); /* Current unix time  */
		    $since = $today - $mysqlstamp;
		
		// $j saves performing the count function each time around the loop
		for ($i = 0, $j = count($chunks); $i < $j; $i++) {
		
		    $seconds = $chunks[$i][0];
		    $name = $chunks[$i][1];
		
		    // finding the biggest chunk (if the chunk fits, break)
		    if (($count = floor($since / $seconds)) != 0) {
		        break;
		    }
		}
		
		$jakdata = (($count == 1) ? '1 '.$name : "$count {$name}".JAK_MULTITIME).' '.JAK_AGO;
		
		} else {
		
			$jakdata = date($date.$time, $mysqlstamp);
		}
		
		return $jakdata;
	
	}
	
	public static function jakGetallcategories()
	{
		global $jakdb;
		
		$result = $jakdb->query('SELECT id, name'.$_SESSION['jak_language_sc'].', varname, exturl, catimg, showmenu, showfooter, catparent, catorder, catparent2, subexist, subsubexist, pageid, activeplugin, permission, pluginid FROM '.DB_PREFIX.'categories WHERE ((pageid > 0 AND activeplugin = 1) OR (pageid = 0 AND pluginid > 0) OR (exturl != "" AND pageid = 0 AND pluginid = 0)) ORDER BY catorder ASC');
		
		while ($row = $result->fetch_assoc()) {
		
			$permission = explode(',', $row['permission']);
			
			if (in_array(JAK_USERGROUPID, $permission) || $row['permission'] == 0) {
		
			$catexist = 0;
			$catexist2 = 0;
			
			// Check if sub exist 
			if ($row['subexist']) {
					$catexist = 1;
				}
				// Check for subsubcat
				if ($row['subsubexist']) {
						$catexist2 = 1;
					}
				
				if ($row['catorder'] == 1 && $row['catparent'] == 0) {
					$parseurl = JAK_rewrite::jakParseurl('', '', '', '', '');
				} else if ($row['varname'] && !$row['exturl']) {
					$parseurl = JAK_rewrite::jakParseurl($row['varname'], '', '', '', '');
				} else if ($row['exturl']) {
					$parseurl = $row['exturl'];
				} else {
					$parseurl = JAK_rewrite::jakParseurl('', '', '', '', '');
				}
					
					$jakdata[] = array('id' => $row['id'], 'name' => $row['name'.$_SESSION['jak_language_sc']], 'varname' => $parseurl, 'pagename' => $row['varname'], 'showmenu' => $row['showmenu'], 'showfooter' => $row['showfooter'], 'catorder' => $row['catorder'], 'catimg' => $row['catimg'], 'catparent' => $row['catparent'], 'catparent2' => $row['catparent2'], 'catexist' => $catexist, 'catexist2' => $catexist2, 'activeplugin' => $row['activeplugin'], 'pluginid' => $row['pluginid'], 'pageid' => $row['pageid']);
		    }
		    
		    }
		    
		return $jakdata;
		
	}
	
	public static function jakGetcatmix($where, $where1, $table, $usergroup, $dseo)
	{
			
		global $jakdb;
		$result = $jakdb->query('SELECT * FROM '.$table.' WHERE active = 1 ORDER BY catorder ASC');
		while ($row = $result->fetch_assoc()) {
		
			if (jak_get_access($usergroup, $row['permission']) || $row['permission'] == 0) {
		
				$seo = '';
				
				// There should be always a varname in categories and check if seo is valid
				if ($dseo) {
					$seow = $row['varname'];
				}
				
				$row['parseurl'] = JAK_rewrite::jakParseurl($where, 'c', $row['id'], $seow, '');
				
				if ($where1) {
					$row['parseurl1'] = JAK_rewrite::jakParseurl($where1, $where, $row['id'], '', '');
				}
				
				if ($row['name'.$_SESSION['jak_language_sc']]) {
					$row['name'] = $row['name'.$_SESSION['jak_language_sc']];
				} else {
					$row['name'] = $row['name'];
				}
				
				if ($row['content'.$_SESSION['jak_language_sc']]) {
					$row['content'] = $row['content'.$_SESSION['jak_language_sc']];
				} else {
					$row['content'] = $row['content'];
				}
				
				// collect each record into $jakdata
				$jakdata[] = $row;
				
			}
		}      
		      
		  return $jakdata;
	}
	
	public static function jakCatdisplay($jakvar, $usraccesspl, $catarray)
	{
	
		$getc = $catarray;
		
		foreach($getc as $c)
		{
			if ($c['pluginid'] == 0 || in_array($c['pluginid'], $usraccesspl))
				$case[] = $c;
				
		}
		
		return $case;
	
	}
	
	public static function jakCatpluginvar($id, $catarray)
	{
	
		$getc = $catarray;
		
		foreach($getc as $c)
		{
			if ($c['id'] == $id)
				$case = $c['pagename'];
				
		}
		
		return $case;
	
	}
	
	public static function jakUpdatehits($jakvar,$jakvar1)
	{
		
		global $jakdb;
		
		$sql = 'UPDATE '.$jakvar1.' SET hits = hits + 1 WHERE id = "'.smartsql($jakvar).'"';
		$result = $jakdb->query($sql);
	
	}
	
	public static function jakSessiontimelimit()
	{
		
		// Start the session
		session_start();
		
		// Set new after 10 minutes
		$inactive = 600;
		
		// check to see if $_SESSION['timeout'] is set
		if(isset($_SESSION['timeout']) ) {
			$session_life = time() - $_SESSION['timeout'];
			
			if($session_life > $inactive) { 
				
				$loadnew = false;
				
				// Write the session timeout new, because the 10 minutes are over
				$_SESSION['timeout'] = time();
			} else {
				
				$loadnew = true;
			} 
		} else {
		
			// Write the session timeout new
			$_SESSION['timeout'] = time();
		
		}
		
		return $loadnew;
	}
	
	public static function jakCheckprotectedArea($pass, $table, $id)
	{
	
		global $jakdb;
		$jakdb->query('SELECT id FROM '.DB_PREFIX.$table.' WHERE password = "'.$pass.'" AND id = '.$id.' AND active = 1');
		if ($jakdb->affected_rows > 0) {
			return true;
		} else {
			return false;
		}
			
	}
	
	public static function jakWriteinCache($file, $content, $extra)
	{
	
		if ($file && $content) {
		
			if (isset($extra)) {
				file_put_contents($file, $content, FILE_APPEND | LOCK_EX);
			} else {
				file_put_contents($file, $content, LOCK_EX);
			}
		}
	
	}

}
?>