<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

class JAK_plugins
{
	private $data = array();
	private $case = array();
	private $sqlwhere = '';
	private $sqlwhere1 = '';
	
	public function __construct($active, $cache)
	{
		/*
		/	The constructor
		*/
		
		if (file_exists($cache)) {
			include_once $cache;
		} else {
		
		if ($active == 1) {
			$sqlwhere = ' WHERE active = 1';
			$sqlfrom = 'id, name, active, phpcode, sidenavhtml, usergroup';
		}
		if ($active == 2) {
			$sqlwhere = ' WHERE FIND_IN_SET('.JAK_USERID_CMS.', access)';
			$sqlfrom = 'id, name, description, active, access, pluginorder, pluginpath, phpcode, phpcodeadmin, sidenavhtml, managenavhtml, usergroup, uninstallfile, pluginversion, time';
		}
		
		$jakplugins = array();
		global $jakdb;
		$sql = 'SELECT '.$sqlfrom .' FROM '.DB_PREFIX.'plugins'.$sqlwhere.' ORDER BY pluginorder ASC';
		$result = $jakdb->query($sql);
		while ($row = $result->fetch_assoc()) {
			
			// Check if user has access to one of them
		    $jakplugins[] = $row;
		}
		
		if (!file_exists($cache)) {
		
			// Now get the categories into the file and serialized
			$plugf = "<?php\n\$plugserialize = '".base64_encode(gzcompress(serialize($jakplugins)))."';\n\n\$jakplugins = unserialize(gzuncompress(base64_decode(\$plugserialize)));\n?>";
			JAK_base::jakWriteinCache($cache, $plugf, '');
		
		}
		
		}
		
		$this->data = $jakplugins;
	}
	
	public function jakGetarray()
	{
		// Setting up an alias, so we don't have to write $this->data every time:
		$d = $this->data;
		
		return $d;
		
	}
	
	public function jakAdmintopnav()
	{
		// Setting up an alias, so we don't have to write $this->data every time:
		$d = $this->data;
		
		foreach($d as $c)
		{
			if ($c['active'] == 1 && !empty($c['sidenavhtml']))
			$case[] = $c['sidenavhtml'];
		}
		
		return $case;
		
	}
	
	public function jakAdminmanagenav()
	{
		// Setting up an alias, so we don't have to write $this->data every time:
		$d = $this->data;
		
		foreach($d as $c)
		{
			if ($c['active'] == 1 && !empty($c['managenavhtml']))
			$case[] = $c['managenavhtml'];
		}
		
		return $case;
		
	}
	
	public function jakAdminindex()
	{
		// Setting up an alias, so we don't have to write $this->data every time:
		$d = $this->data;
		
		foreach($d as $c)
		{
			if ($c['active'] == 1 && !empty($c['phpcodeadmin'])) {
				$case[] = array('id' => $c['id'], 'name' => $c['name'], 'access' => $c['access'], 'phpcode' => $c['phpcodeadmin']);
			}
		}
		
		return $case;
	}
	
	public function jakSiteindex()
	{
		// Setting up an alias, so we don't have to write $this->data every time:
		$d = $this->data;
		
		foreach($d as $c)
		{
			if (!empty($c['phpcode']))
			$case[] = $c['phpcode'];
		}
		
		return $case;
	}
	
	public function jakAdmintag()
	{
		// Setting up an alias, so we don't have to write $this->data every time:
		$d = $this->data;
		
		foreach($d as $c)
		{
			if ($c['active'] == 1) {
				$case[] = array('id' => $c['id'], 'name' => $c['name']);
			}
		}
		
		return $case;
	}
	
	public function getPHPcodeid($id, $field)
	{
		// Setting up an alias, so we don't have to write $this->data every time:
		$d = $this->data;
		
			foreach($d as $c)
			{
				if ($c['id'] == $id) {
					$case = $c[$field];
				}
			}
		
		return $case;
		
	}
	
	public function getIDfromName($name)
	{
		// Setting up an alias, so we don't have to write $this->data every time:
		$d = $this->data;
		
			foreach($d as $c)
			{
				if ($c['name'] == $name) {
					$case = $c['id'];
				}
			}
		
		return $case;
		
	}

}
?>