<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

class JAK_search 
{
	protected $table = '', $fields = '', $andor = '', $select = '', $plugin = '', $link = '', $dseo = '';
	
	
    function JAK_search($keyword) 
    { 
        // filter the keywords
        $filtered = filter_var($keyword, FILTER_SANITIZE_STRING);
        $this->keyword = strtolower($filtered); 
    }
    
    function jakSettable($table, $on) 
    { 
        // Set the table to search trhu but also check if there is more then one!
        if (is_array($table)) {
        	foreach($table as $k => $t)
        		{
        			$tablearray[] = DB_PREFIX.$t.' AS t'.$k.'';
        		}
        	$missingon = join(" LEFT JOIN ".$this->andor." ", $tablearray);
        	$this->table = $missingon.' ON '.$on;
        } else {
        
        	$this->table = DB_PREFIX.$table;
        }
    }
    
    function jakAndor($andor) 
    { 
        // Set if the search should AND/OR
        $this->andor = $andor; 
    }
    
    function jakFieldstoselect($select) 
    { 
        // What fields should we select 
        $this->select = $select; 
    }
    
    function jakFieldtitle($seotitle) 
    { 
        // What fields should we select 
        $this->title = $seotitle; 
    }
    
    function jakFieldcut($cutme) 
    { 
        // What fields should we select 
        $this->cut = $cutme; 
    }
    
    function jakFieldactive($active) 
    { 
        // What fields should we check if this article is active or approved
        if (isset($active)) {
        	$this->active = ' AND '.$active.' = 1';
        } else {
        	$this->active = '';
        }
        
    }
    
    function jakSearchlimit($limited)
    {
    	// Get the limit for this search
    	$this->limited = $limited;
    }
    
    function jakTablegroup($groupme)
    {
    	// Get the limit for this search
    	$this->groupme = ' GROUP BY '.$groupme;
    }
    
    function jakFieldstosearch($fields) 
    {
    	
    	// Check if mysql full text search is enabled
    	if (JAK_FULLTEXTSEARCH) {
    			
    			$this->fields = 'MATCH('.implode(',', $fields).') AGAINST("'.$this->keyword.'" IN BOOLEAN MODE)'.$this->active;
    	
    	} else {
    	
	    	// Write the where clause
	    	foreach($fields as $f)
	   		{
	   			$search[] = 'LOWER('.$f.') LIKE "%'.$this->keyword.'%"'.$this->active;
	   		}
   		$this->fields = join(" ".$this->andor." ", $search);
   		
   		}
    }
     
    function set_result($plugin, $link, $dseo) 
    {
    
        // do the dirty work in in mysql    
        global $jakdb;
        
        // Catch the limit if not set, we set it to 10
        if (!$this->limited)
        	$this->limited = 10;
        
        // SQL Querie(s)
        $sql = 'SELECT '.$this->select.' FROM '.$this->table.' WHERE '.$this->fields.$this->groupme.' LIMIT '.$this->limited.''; 
        $result = $jakdb->query($sql);
        while ($row = $result->fetch_assoc()) 
        	{
        		$wseo = '';
        	
        		// cut me $this->cut
        		if ($this->cut) {
            		$shorty = jak_cut_text($row[$this->cut],JAK_SHORTMSG,'...');
            	}
            	
            	if ($row['title'.$_SESSION['jak_language_sc']]) {
            		$title = $row['title'.$_SESSION['jak_language_sc']];
            	} else {
            		$title = $row['title'];
            	}
            	
            	// get the title for better seo, if there is a title
            	if ($dseo && $this->title) {
            		$wseo = JAK_base::jakCleanurl($row[$this->title]);
       			}
       			
       			if ($row['catorder'] == 1 && $row['catparent'] == 0) {
       				$parseurl = BASE_URL;
       			} else if ($row['varname'] && !$plugin) {
       				$parseurl = JAK_rewrite::jakParseurl($row['varname'], $link, $row['id'], $wseo, '');
       			} else {
       				$parseurl = JAK_rewrite::jakParseurl($plugin, $link, $row['id'], $wseo, '');
       			}
            	
            	$this->found[] = array('parseurl' => $parseurl, 'title' => $title, 'content' => $shorty);
            	 
            }
            
        return $this->found; 
    }
    
    public static function search_cloud($searchterm)
    {
    	
    	global $jakdb;
    	// save the search term into the database for further use
    	$results = $jakdb->query('SELECT id FROM '.DB_PREFIX.'searchlog WHERE tag = "'.$searchterm.'"');
    	if ($jakdb->affected_rows > 0) {
    	    $rows = $results->fetch_assoc();
    	    $jakdb->query('UPDATE '.DB_PREFIX.'searchlog SET count = count + 1 WHERE id = "'.smartsql($rows['id']).'"');
    	} else {
    	    $jakdb->query('INSERT INTO '.DB_PREFIX.'searchlog SET tag = "'.$searchterm.'", time = NOW()');
    	}
    
    }
}
?>