<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

// Check if the file is accessed only via index.php if not stop the script from running
if(!defined('JAK_PREVENT_ACCESS')) die('No direct access!');

// Get the database table
$jaktable = DB_PREFIX.'news';

// parse url
$backtonews = JAK_rewrite::jakParseurl(JAK_PLUGIN_VAR_NEWS, '', '', '', '');

// AJAX Search
$AJAX_SEARCH_PLUGIN_WHERE = $jaktable;
$AJAX_SEARCH_PLUGIN_URL = 'include/ajax/news.php';
$AJAX_SEARCH_PLUGIN_SEO =  1;
$JAK_SEARCH_LINK = JAK_PLUGIN_VAR_NEWS;

// The new parsing method for url and passing it to template
$P_NEWS_URL = $backtonews;

// Get the CSS and Javascript into the page
$JAK_HEADER_CSS = JAK_NEWS_CSS;
$JAK_FOOTER_JAVASCRIPT = JAK_NEWS_JAVASCRIPT;

switch ($page1) {

	case 'a':
		
		if (is_numeric($page2)) {
		
			$page2 = filter_var($page2, FILTER_SANITIZE_NUMBER_INT);
			
			// Now perform the query
			$result = $jakdb->query('SELECT * FROM '.$jaktable.' WHERE ((startdate = 0 OR startdate <= '.time().') AND (enddate = 0 OR enddate >= '.time().')) AND (FIND_IN_SET('.JAK_USERGROUPID.',permission) OR permission = 0) AND id = '.smartsql($page2));
			
			if ($jakdb->affected_rows == 0) jak_redirect($backtonews);
			
			$row = $result->fetch_assoc();
			
			// News is not active redirect to offline news
			if ($row['active'] != 1 && !JAK_ASACCESS) {
				jak_redirect(JAK_rewrite::jakParseurl($tl['link']['l3'], $tl['errornews']['non'], '', '', ''));
			// Everything works fine, display the news!	
			} else {
			
				// Now let's check the vote and hits cookie
				if (!jak_cookie_voted_hits($jaktable, $row['id'], $_COOKIE['hits'])) {
				
					jak_write_vote_hits_cookie($jaktable, $row['id'], 'hits');
					
					// Update hits each time
					JAK_base::jakUpdatehits($row['id'],$jaktable);
				}
			
				$PAGE_ID = $row['id'];
				$PAGE_TITLE = $row['title'.$_SESSION['jak_language_sc']];
				$PAGE_CONTENT = jak_secure_site($row['content'.$_SESSION['jak_language_sc']]);
				$JAK_HEADER_CSS = $row['news_css'];
				$JAK_FOOTER_JAVASCRIPT = $row['news_javascript'];
				$JAK_SIDEBAR_LOCATION = $row['sidebar'];
				$SHOWTITLE = $row['showtitle'];
				$SHOWDATE = $row['showdate'];
				$SHOWSOCIALBUTTON = $row['socialbutton'];
				$SHOWVOTE = $row['showvote'];
				$PAGE_ACTIVE = $row['active'];
				$PAGE_HITS = $row['hits'];
				$PAGE_TIME = JAK_base::jakTimesince($row['time'], JAK_NEWSDATEFORMAT, JAK_NEWSTIMEFORMAT);
				$PAGE_TIME_HTML5 = date("Y-m-d", strtotime($row['time']));
				$JAK_HEATMAPLOC = "news_".$row['id'];
				
				// Now let's check if the language is available otherwise we go back to standard
				if (!$PAGE_TITLE && !$PAGE_CONTENT) {
					$PAGE_TITLE = $row['title'];
					$PAGE_CONTENT = $row['content'];
					$LANG_MISSING = $tl['general']['g175'];
				}
				
				// Display contact form if whish so and do the caching
				if ($row['showcontact'] != 0) {
					$cachecontactfile = APP_PATH.JAK_CACHE_DIRECTORY.'/contact'.$row['showcontact'].'.php';
					if (!file_exists($cachecontactfile)) {
						$JAK_SHOW_C_FORM = jak_create_contact_form($row['showcontact'], $tl['cmsg']['c12']);
					}
					
					$JAK_SHOW_C_FORM_NAME = jak_contact_form_title($row['showcontact']);
					$JAK_SHOW_C_FORM = 1;
					
				}
		
		// Get the rating
		if (USR_CAN_RATE && $SHOWVOTE) {
		
			// Now let's check the vote and hits cookie
			if (isset($_COOKIE['vote']) && jak_cookie_voted_hits($jaktable, $row['id'], $_COOKIE['vote'])) {
				
				$ALLOW_TO_VOTE = false;
				
			} else {
			
				$ALLOW_TO_VOTE = true;
			}
			
			$VOTE_TABLE = $jaktable;
			
			// Get the vote bar
			$VOTETOTAL = $row['voteup'] + $row['votedown'];
			if ($VOTETOTAL) {
				$VOTEUP_PER = ($row['voteup'] * 92) / $VOTETOTAL;
				$VOTEDOWN_PER = ($row['votedown'] * 92) / $VOTETOTAL;
			}
			
			$VOTEUP = $row['voteup'];
			$VOTEDOWN = $row['votedown'];
		}
		
		// Inject some code for news
		$hna = $jakhooks->jakGethook("php_pages_news");
		if ($hna) { foreach($hna as $c)
		{
			eval($c["phpcode"]);
		}
		}
		
		// news grid cache file
		$cachenewsgridfile = APP_PATH.JAK_CACHE_DIRECTORY.'/news'.$row['id'].$_SESSION['jak_language_sc'].'.php';
		
		if (!file_exists($cachenewsgridfile)) {
		
		// Get the sort orders for the grid
		$grid = $jakdb->query('SELECT id, pluginid, hookid, whatid, orderid FROM '.DB_PREFIX.'pagesgrid WHERE newsid = "'.$row['id'].'" ORDER BY orderid ASC');
		while ($grow = $grid->fetch_assoc()) {
		        // collect each record into $newsgrid
		        if ($grow["pluginid"] && !$grow["hookid"]) {
		        	$newsgrid[] = $grow;
		        }
		        
		        if ($grow["hookid"]) {
		        	$hookgrid[] = $grow;
		        }
		}
		
		// Show Tags
		$JAK_TAGLIST = JAK_tags::jakGettaglist($page2, JAK_PLUGIN_ID_NEWS, JAK_PLUGIN_VAR_TAGS);
		
		// Page Nav
		$nextp = jak_next_page($page2, 'title'.$_SESSION['jak_language_sc'], $jaktable, 'id', '', '', 'active');
		if ($nextp) {
			$JAK_NAV_NEXT = JAK_rewrite::jakParseurl(JAK_PLUGIN_VAR_NEWS, 'a', $nextp['id'], JAK_base::jakCleanurl($nextp['title'.$_SESSION['jak_language_sc']]), '');
			$JAK_NAV_NEXT_TITLE = addslashes($nextp['title'.$_SESSION['jak_language_sc']]);
		}
		
		$prevp = jak_previous_page($page2, 'title'.$_SESSION['jak_language_sc'], $jaktable, 'id', '', '', 'active');
		if ($prevp) {
			$JAK_NAV_PREV = JAK_rewrite::jakParseurl(JAK_PLUGIN_VAR_NEWS, 'a', $prevp['id'], JAK_base::jakCleanurl($prevp['title'.$_SESSION['jak_language_sc']]), '');
			$JAK_NAV_PREV_TITLE = addslashes($prevp['title'.$_SESSION['jak_language_sc']]);
		}
		
		$newsgf = "<?php\n\$newsgserialize = '".base64_encode(gzcompress(serialize($newsgrid)))."';\n\n\$JAK_PAGE_GRID = unserialize(gzuncompress(base64_decode(\$newsgserialize)));\n\n\$hookserialize = '".base64_encode(gzcompress(serialize($hookgrid)))."';\n\n\$JAK_HOOK_SIDE_GRID = unserialize(gzuncompress(base64_decode(\$hookserialize)));\n\n\$JAK_TAGLIST = '".$JAK_TAGLIST."';\n\n\$JAK_NAV_NEXT = '".$JAK_NAV_NEXT."';\n\n\$JAK_NAV_NEXT_TITLE = '".$JAK_NAV_NEXT_TITLE."';\n\n\$JAK_NAV_PREV = '".$JAK_NAV_PREV."';\n\n\$JAK_NAV_PREV_TITLE = '".$JAK_NAV_PREV_TITLE."';\n?>";
		
		JAK_base::jakWriteinCache($cachenewsgridfile, $newsgf, '');
		
		}
		
		$JAK_HOOK_NEWS_GRID = $jakhooks->jakGethook("tpl_page_news_grid");
		
		// Get the url session
		$_SESSION['jak_lastURL'] = JAK_rewrite::jakParseurl($tl['link']['l3'], $page1, $page2, $page3, '');
		
		// Now include the created news grid file
		include_once $cachenewsgridfile;
		
		}
		
		// Now get the new meta keywords and description maker
		$PAGE_KEYWORDS = str_replace(" ", "", JAK_Base::jakCleanurl($PAGE_TITLE).($JAK_TAGLIST ? ",".strip_tags($JAK_TAGLIST) : "").(JAK_METAKEY ? ",".JAK_METAKEY : ""));
		$PAGE_DESCRIPTION = jak_cut_text($PAGE_CONTENT, 155, '');
		
		// Fire the template
		$template = 'newsart.php';
		
		} else {
			jak_redirect($backtonews);
		}
	
	break;
	default:
	
		$newsloadonce = false;
		
		$getTotal = jak_get_total($jaktable, 1, 'active', '');
		
			if ($getTotal != 0) {
			// Paginator
				$news = new Paginator;
				$news->items_total = $getTotal;
				$news->mid_range = JAK_NEWSPAGEMID;
				$news->items_per_page = JAK_NEWSPAGEITEM;
				$news->jak_get_page = $page1;
				$news->jak_where = $backtonews;
				$news->jak_prevtext = $tl["general"]["g171"];
				$news->jak_nexttext = $tl["general"]["g172"];
				$news->paginate();
				
				$JAK_PAGINATE = $news->display_pages();
				
				// Display the news
				$JAK_NEWS_ALL = jak_get_news($news->limit, '', JAK_PLUGIN_VAR_NEWS, 'ASC', $tl['general']['g175']);
			}
			
			// Check if we have a language and display the right stuff
			if (JAK_LANG2 && $_SESSION['jak_language'] == JAK_LANG2 && defined('JAK_NEWSTITLE_L2')) {
			
				$PAGE_TITLE = JAK_NEWSTITLE_L2;
				$PAGE_CONTENT = JAK_NEWSDESC_l2;
					
			} elseif (JAK_LANG3 && $_SESSION['jak_language'] == JAK_LANG3 && defined('JAK_NEWSTITLE_L3')) {
				
				$PAGE_TITLE = JAK_NEWSTITLE_L3;
				$PAGE_CONTENT = JAK_NEWSDESC_l3;
				
			} else {
				
				$PAGE_TITLE = JAK_NEWSTITLE;
				$PAGE_CONTENT = JAK_NEWSDESC;
				
			}
			
			$JAK_HEATMAPLOC = JAK_PLUGIN_VAR_NEWS;
			
			$JAK_HOOK_NEWS = $jakhooks->jakGethook("tpl_news");
			
			$PAGE_SHOWTITLE = 1;
			
			// Get the url session
			$_SESSION['jak_lastURL'] = $backtonews;
			
			// Get the sort orders for the grid
			$grid = $jakdb->query('SELECT id, hookid, pluginid, whatid, orderid FROM '.DB_PREFIX.'pagesgrid WHERE plugin = '.JAK_PLUGIN_ID_NEWS.' ORDER BY orderid ASC');
			while ($grow = $grid->fetch_assoc()) {
			        // collect each record into $pagegrid
			        	$hookgrid[] = $grow;
			}
			
			$JAK_HOOK_SIDE_GRID = $hookgrid;
			
			// Now get the new meta keywords and description maker
			if (isset($JAK_NEWS_ALL) && is_array($JAK_NEWS_ALL)) foreach($JAK_NEWS_ALL as $v) $newskeywords[] = JAK_Base::jakCleanurl($v['title']);
			
			if (!empty($newskeywords)) $keylist = join(",", $newskeywords);
			
			$PAGE_KEYWORDS = str_replace(" ", "", JAK_Base::jakCleanurl($PAGE_TITLE).($keylist ? ",".$keylist : "").(JAK_METAKEY ? ",".JAK_METAKEY : ""));
			$PAGE_DESCRIPTION = jak_cut_text($PAGE_CONTENT, 155, '');
			
			// get the standard template
			$template = 'news.php';
}
?>