<?php

/*======================================================================*\
|| #################################################################### ||
|| # GECKO 2.1                                                        # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Gecko All Rights Reserved.                        # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| #   ---------------- Gecko IS NOT FREE SOFTWARE ----------------   # ||
|| # http://www.cmsgecko.com | http://www.cmsgecko.com/license        # ||
|| #################################################################### ||
\*======================================================================*/

if (!file_exists('../../config.php')) die('[install.php] config.php not found');
require_once '../../config.php';

// Check if the file is accessed only from a admin if not stop the script from running
if (!JAK_USERID_CMS) die('You cannot access this file directly.');

if(!$jakuser->jakAdminaccess(JAK_USERID_CMS)) die('You cannot access this file directly.');

// Set successfully to zero
$succesfully = 0;

?>

<!DOCTYPE html>
<html lang="en">
<head>
	<title>Installation - Open URL in a new Window</title>
	<meta charset="utf-8">
	<meta name="author" content="Gecko CMS" />
	<link rel="stylesheet" href="../../css/stylesheet.css" type="text/css" media="screen" />
</head>
<body>

<div class="container-fluid">
<div class="row-fluid">
<div class="span12">
<h3>Installation - Open URL in a new Window</h3>

<!-- Check if the plugin is already installed -->
<?php $jakdb->query('SELECT id FROM '.DB_PREFIX.'plugins WHERE name = "openurl_blank"');
if ($jakdb->affected_rows > 0) { ?>

<div class="alert alert-success fade in">
  <button type="button" class="close" data-dismiss="alert">×</button>
  <h4>Plugin is already installed!!!</h4>
</div>

<!-- Plugin is not installed let's display the installation script -->
<?php } else { ?>

<!-- The installation button is hit -->
<?php if (isset($_POST['install'])) {
 
$jakdb->query('INSERT INTO '.DB_PREFIX.'plugins (`id`, `name`, `description`, `active`, `access`, `pluginorder`, `pluginpath`, `phpcode`, `phpcodeadmin`, `sidenavhtml`, `usergroup`, `uninstallfile`, `pluginversion`, `time`) VALUES (NULL, "openurl_blank", "Open all external links in a new window/tab.", 1, '.JAK_USERID_CMS.', 1, "openurl_blank", NULL, NULL, NULL, NULL, "uninstall.php", "1.0", NOW())');

// now get the plugin id for futher use
$results = $jakdb->query('SELECT id FROM '.DB_PREFIX.'plugins WHERE name = "openurl_blank"');
$rows = $results->fetch_assoc();

if ($rows['id']) {

$jakdb->query('INSERT INTO '.DB_PREFIX.'pluginhooks (`id`, `hook_name`, `name`, `phpcode`, `product`, `active`, `exorder`, `pluginid`, `time`) VALUES (NULL, "tpl_between_head", "Open URL jQuery", "plugins/openurl_blank/openurlhead.php", "openurlb", 1, 1, "'.$rows['id'].'", NOW())');

$succesfully = 1;

// Now let us delete the hook cache file
$cachehookfile = '../../'.JAK_CACHE_DIRECTORY.'/hooks.php';
if (file_exists($cachehookfile)) {
	unlink($cachehookfile);
}

// Now let us delete the plugin cache file
$cacheplugfile = '../../'.JAK_CACHE_DIRECTORY.'/plugins.php';
if (file_exists($cacheplugfile)) {
	unlink($cacheplugfile);
}

?>
<div class="alert alert-success fade in">
  <button type="button" class="close" data-dismiss="alert">×</button>
  <h4>Plugin installed successfully.</h4>
</div>
<?php } else { 

$result = $jakdb->query('DELETE FROM '.DB_PREFIX.'plugins WHERE name = "openurl_blank"');

?>

<div class="alert alert-error fade in">
  <button type="button" class="close" data-dismiss="alert">×</button>
  <h4>Plugin installation failed.</h4>
</div>

<?php } } if (!$succesfully) { ?>
<form name="company" method="post" action="install.php" enctype="multipart/form-data">
<div class="form-actions">
<button type="submit" name="install" class="btn btn-primary pull-right">Install Plugin</button>
</div>
</form>
<?php } } ?>

</div>
</div>

<hr>

<footer>
	<p>Copyright 2008 - <?php echo date('Y');?> by another Gecko is crawling…</p>
</footer>

</div>

</body>
</html>