<!DOCTYPE html>
<html lang="<?php echo JAK_LANGCONTROL;?>">
<head>
	<meta charset="utf-8">
	<title><?php echo $PAGE_TITLE; if ($PAGE_TITLE) { ?> - <?php } echo JAK_TITLE;?></title>
	<?php if (JAK_RESPONSIVE_TPL == 'respy') { ?>
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<?php } ?>
	<meta name="keywords" content="<?php echo trim($PAGE_KEYWORDS);?>" />
	<meta name="description" content="<?php echo trim($PAGE_DESCRIPTION);?>" />
	<meta name="author" content="<?php echo JAK_METAAUTHOR;?>" />
	<meta name="robots" content="<?php echo JAK_ROBOTS;?>" />
	<?php if ($page == "success" or $page == "logout") { ?>
	<meta http-equiv="refresh" content="1;URL=<?php echo $_SERVER['HTTP_REFERER'];?>" />
	<?php } ?>
	
	<link rel="stylesheet" href="<?php echo BASE_URL;?>css/stylesheet.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" />
	<?php if (JAK_CONTENT_CLASSIC_TPL == 'black') { ?>
	<link rel="stylesheet" href="<?php echo BASE_URL;?>template/classic/css/dark.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" />
	<?php } ?>
	<link rel="stylesheet" href="<?php echo BASE_URL;?>template/classic/css/screen.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" />
	<link rel="stylesheet" href="<?php echo BASE_URL;?>js/colorbox/colorbox.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" />
	<?php if (JAK_FONTG_CLASSIC_TPL != "NonGoogle") { ?>
	<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=<?php echo JAK_FONTG_CLASSIC_TPL;?>:regular,italic,bold,bolditalic" type="text/css" />
	<?php } ?>
	
	<style type="text/css">
		h1, h2, h3, h4, h5, h6 { font-family:<?php if (JAK_FONTG_CLASSIC_TPL != "NonGoogle") echo '"'.str_replace("+", " ", JAK_FONTG_CLASSIC_TPL).'", '; echo JAK_FONT_CLASSIC_TPL;?>; }
	</style>
	<style id="cFontStyles" type="text/css">
		body, code, input[type="text"], textarea { font-family:<?php echo JAK_FONT_CLASSIC_TPL;?>; }
	</style>
	<?php if (JAK_FHCOLOR_CLASSIC_TPL != '#fefefe') { ?>
	<style type="text/css">
		h1, h2, h3, h4, h5, h6 { color: <?php echo JAK_FHCOLOR_CLASSIC_TPL;?>; }
	</style>
	<?php } if (JAK_FHCCOLOR_CLASSIC_TPL != '#fefefe') { ?>
	<style type="text/css">
		.middle h1.entry-title, .middle .sidebar h3 { color: <?php echo JAK_FHCCOLOR_CLASSIC_TPL;?>; }
	</style>
	<?php } if (JAK_FCOLOR_CLASSIC_TPL != '#fefefe') { ?>
	<style type="text/css">
		body { color: <?php echo JAK_FCOLOR_CLASSIC_TPL;?>; }
	</style>
	<?php } if (JAK_FACOLOR_CLASSIC_TPL != '#e6e1a8') { ?>
	<style type="text/css">
		a { color: <?php echo JAK_FACOLOR_CLASSIC_TPL;?>; }
	</style>
	<?php } if (JAK_BGCOLOR_CLASSIC_TPL || JAK_BG_CLASSIC_TPL) { ?>
	<style type="text/css">
		body {
			<?php if (JAK_BGCOLOR_CLASSIC_TPL) echo 'background:'.JAK_BGCOLOR_CLASSIC_TPL.';'; ?>
			<?php if (JAK_BG_CLASSIC_TPL) echo 'background: url('.JAK_BG_CLASSIC_TPL.') no-repeat center center fixed;'; ?>
			<?php if (JAK_REPEAT_CLASSIC_TPL) echo 'background-repeat:repeat; background-position:0 0; background-attachment:scroll;';?>
		}
	</style>
	<?php } ?>
	
	<?php if ($JAK_RSS_DISPLAY) { ?>
	<link rel="alternate" type="application/rss+xml" title="<?php echo JAK_TITLE.$JAK_RSS_TITLE;?> RSS 2.0" href="<?php echo $P_RSS_LINK;?>" />
	<?php } ?>
	
	<script type="text/javascript" src="<?php echo BASE_URL;?>js/jquery.js?=<?php echo JAK_UPDATETIME;?>"></script>
	<script type="text/javascript" src="<?php echo BASE_URL;?>js/functions.js?=<?php echo JAK_UPDATETIME;?>"></script>
	<script type="text/javascript" src="<?php echo BASE_URL;?>js/colorbox/colorbox.js?=<?php echo JAK_UPDATETIME;?>"></script>
	
	<?php if (JAK_PRINTME) { ?>
	<script type="text/javascript" src="<?php echo BASE_URL;?>js/jakprint.js?=<?php echo JAK_UPDATETIME;?>"></script>
	
	<script type="text/javascript">
	$(document).ready(function() {
		$("a#jakprint").click(function(e) {
			e.preventDefault();
			$('div#printdiv').printElement();
		});
	});
	</script>
	
	<?php } ?>
	
	<!-- Import templates for in between head -->
	<?php if (isset($JAK_HOOK_HEAD_TOP) && is_array($JAK_HOOK_HEAD_TOP)) foreach($JAK_HOOK_HEAD_TOP as $headt) { include_once APP_PATH.$headt['phpcode']; } echo $JAK_HEADER_CSS;?>
	
	<?php if (JAK_RESPONSIVE_TPL == 'respy') { ?>
	<!-- Responsive Stylesheet plus custom modifications -->
	<link rel="stylesheet" href="<?php echo BASE_URL;?>css/stylesheet-responsive.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" media="screen" />
	<link rel="stylesheet" href="<?php echo BASE_URL;?>template/classic/css/responsive.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" />
	<?php } if (!JAK_LANGDIRECTION) { ?>
	<!-- RTL Support -->
	<link rel="stylesheet" href="<?php echo BASE_URL;?>template/classic/css/rtlscreen.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" media="screen" />
	<!-- End RTL Support -->
	<?php } ?>
	
	<!-- Again IE needs some special modifcations, but at least we do it with style… ;) -->
	<!--[if lt IE 9]>
	<script src="https://html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	 <![endif]-->
	
</head>
<body>

<!-- Import templates before everything -->
<?php if (isset($JAK_HOOK_BODY_TOP) && is_array($JAK_HOOK_BODY_TOP)) foreach($JAK_HOOK_BODY_TOP as $bodyt) { include_once APP_PATH.$bodyt['phpcode']; } ?>

<header<?php if (JAK_MHCOLOR_CLASSIC_TPL) echo ' style="background-color:'.JAK_MHCOLOR_CLASSIC_TPL.';"'; ?>>

<!-- Navigation and Logo -->
<div class="container<?php if (JAK_FLUID_TPL == 'fluid') echo "-fluid";?>">
        
	<div class="row<?php if (JAK_FLUID_TPL == 'fluid') echo "-fluid";?>">
	
	<div class="span12">
	
		<div class="logo pull-left"><a class="logo" href="<?php echo BASE_URL;?>"><?php if (JAK_LOGO_CLASSIC_TPL) { echo '<img src="'.JAK_LOGO_CLASSIC_TPL.'" alt="logo" />'; } else { ?><?php echo JAK_TITLE;}?></a></div>
        
        <a class="btn btn-navbar" data-target=".nav-collapse" data-toggle="collapse">
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        </a>
        <div class="nav-collapse collapse">
        	<?php include_once APP_PATH.'template/classic/navbar.php';?>
        </div><!--/.nav-collapse -->
    </div>
    </div>
</div>

<?php if (isset($JAK_HOOK_HEADER) && is_array($JAK_HOOK_HEADER)) foreach($JAK_HOOK_HEADER as $hheader) { include_once APP_PATH.$hheader['phpcode']; } ?>

</header>

<!-- Import templates below header -->
<?php if (isset($JAK_HOOK_BELOW_HEADER) && is_array($JAK_HOOK_BELOW_HEADER)) foreach($JAK_HOOK_BELOW_HEADER as $bheader) { include_once APP_PATH.$bheader['phpcode']; } ?>

<!-- Main Container -->
<div class="container<?php if (JAK_FLUID_TPL == 'fluid') echo "-fluid";?><?php if (JAK_CONTENT_CLASSIC_TPL == 'white') echo ' white';?>">

<!-- Main Row -->
<div class="row<?php if (JAK_FLUID_TPL == 'fluid') echo "-fluid";?>">

<!-- Sidebar if right -->
<?php if (isset($JAK_HOOK_SIDE_GRID) && (JAK_SIDEBAR_CLASSIC_TPL == "left" || $JAK_SIDEBAR_LOCATION)) { include_once APP_PATH.'template/classic/sidebar.php'; } ?>

<div class="<?php echo ($JAK_HOOK_SIDE_GRID ? "span9" : "span12");?> content">