<!DOCTYPE html>
<html lang="<?php echo JAK_LANGCONTROL;?>">
<head>
	<meta charset="utf-8">
	<title><?php echo $PAGE_TITLE; if ($PAGE_TITLE) { ?> - <?php } echo JAK_TITLE;?></title>
	<?php if (JAK_RESPONSIVE_TPL == 'respy') { ?>
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<?php } ?>
	<meta name="keywords" content="<?php echo trim($PAGE_KEYWORDS);?>" />
	<meta name="description" content="<?php echo trim($PAGE_DESCRIPTION);?>" />
	<meta name="author" content="<?php echo JAK_METAAUTHOR;?>" />
	<meta name="robots" content="<?php echo JAK_ROBOTS;?>" />
	<?php if ($page == "success" or $page == "logout") { ?>
	<meta http-equiv="refresh" content="1;URL=<?php echo $_SERVER['HTTP_REFERER'];?>" />
	<?php } ?>
	
	<link rel="stylesheet" href="<?php echo BASE_URL;?>css/stylesheet.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" />
	<link rel="stylesheet" href="<?php echo BASE_URL;?>template/igrid/css/screen.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" />
	
	<link rel="stylesheet" href="<?php echo BASE_URL;?>js/colorbox/colorbox.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" />
	<?php if (JAK_FONTG_IGRID_TPL != "NonGoogle") { ?>
	<link rel="stylesheet" href="http://fonts.googleapis.com/css?family=<?php echo JAK_FONTG_IGRID_TPL;?>:regular,italic,bold,bolditalic" type="text/css" />
	<?php } ?>
	
	<style type="text/css">
		h1, h2, h3, h4, h5, h6 { font-family:<?php if (JAK_FONTG_IGRID_TPL != "NonGoogle") echo '"'.str_replace("+", " ", JAK_FONTG_IGRID_TPL).'", '; echo JAK_FONT_IGRID_TPL;?>; }
	</style>
	<style id="cFontStyles" type="text/css">
		body, code, input[type="text"], textarea { font-family:<?php echo JAK_FONT_IGRID_TPL;?>; }
	</style>
	<?php if (JAK_FHCOLOR_IGRID_TPL != '#659319') { ?>
	<style type="text/css">
		h1, h2, h3, h4, h5, h6 { color: <?php echo JAK_FHCOLOR_IGRID_TPL;?>; }
	</style>
	<?php } if (JAK_FHCCOLOR_IGRID_TPL != '#659319') { ?>
	<style type="text/css">
		.middle h1.entry-title, .middle .sidebar h3 { color: <?php echo JAK_FHCCOLOR_IGRID_TPL;?>; }
	</style>
	<?php } if (JAK_FCOLOR_IGRID_TPL != '#333333') { ?>
	<style type="text/css">
		body { color: <?php echo JAK_FCOLOR_IGRID_TPL;?>; }
	</style>
	<?php } if (JAK_FACOLOR_IGRID_TPL != '#327cba') { ?>
	<style type="text/css">
		a { color: <?php echo JAK_FACOLOR_IGRID_TPL;?>; }
	</style>
	<?php } ?>
	
	<?php if ($JAK_RSS_DISPLAY) { ?>
	<link rel="alternate" type="application/rss+xml" title="<?php echo JAK_TITLE.$JAK_RSS_TITLE;?> RSS 2.0" href="<?php echo $P_RSS_LINK;?>" />
	<?php } ?>
	
	<script src="<?php echo BASE_URL;?>js/jquery.js?=<?php echo JAK_UPDATETIME;?>"></script>
	<script type="text/javascript" src="<?php echo BASE_URL;?>js/functions.js?=<?php echo JAK_UPDATETIME;?>"></script>
	<script type="text/javascript" src="<?php echo BASE_URL;?>js/colorbox/colorbox.js?=<?php echo JAK_UPDATETIME;?>"></script>
	
	<!-- Custom JS igrid -->
	<script type="text/javascript" src="<?php echo BASE_URL;?>template/igrid/js/igrid.js?=<?php echo JAK_UPDATETIME;?>"></script>
	
	<?php if (JAK_PRINTME) { ?>
	<script type="text/javascript" src="<?php echo BASE_URL;?>js/jakprint.js?=<?php echo JAK_UPDATETIME;?>"></script>
	
	<script type="text/javascript">
	$(document).ready(function() {
		$("a#jakprint").click(function(e) {
			e.preventDefault();
			$('div#printdiv').printElement();
		});
	});
	</script>
	
	<?php } ?>
	
	<!-- Import templates for in between head -->
	<?php if (isset($JAK_HOOK_HEAD_TOP) && is_array($JAK_HOOK_HEAD_TOP)) foreach($JAK_HOOK_HEAD_TOP as $headt) { include_once APP_PATH.$headt['phpcode']; } echo $JAK_HEADER_CSS;?>
	
	<?php if (JAK_RESPONSIVE_TPL == 'respy') { ?>
	<!-- Responsive Stylesheet plus custom modifications -->
	<link rel="stylesheet" href="<?php echo BASE_URL;?>css/stylesheet-responsive.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" media="screen" />
	
	<?php } if (!JAK_LANGDIRECTION) { ?>
	<!-- RTL Support -->
	<link rel="stylesheet" href="<?php echo BASE_URL;?>template/igrid/css/rtlscreen.css?=<?php echo JAK_UPDATETIME;?>" type="text/css" media="screen" />
	<!-- End RTL Support -->
	<?php } ?>
	
	<!-- Again IE needs some special modifcations, but at least we do it with style… ;) -->
	<!--[if lt IE 9]>
	<script src="http://html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	 <![endif]-->
	
</head>
<body>

<!-- Import templates before everything -->
<?php if (isset($JAK_HOOK_BODY_TOP) && is_array($JAK_HOOK_BODY_TOP)) foreach($JAK_HOOK_BODY_TOP as $bodyt) { include_once APP_PATH.$bodyt['phpcode']; } ?>

<!-- Navigation and Logo -->
<div class="navbar navbar-inverse navbar-fixed-top">
      <div class="navbar-inner"<?php if (JAK_MCOLOR_IGRID_TPL && JAK_MCOLOR_IGRID_TPL != "#4c4847") echo ' style="background-color:'.JAK_MCOLOR_IGRID_TPL.';background-image:none;"'; ?>>
        <div class="container<?php if (JAK_FLUID_TPL == 'fluid') echo "-fluid";?>">
        	<a class="btn btn-navbar" data-target=".nav-collapse" data-toggle="collapse">
        	<span class="icon-bar"></span>
        	<span class="icon-bar"></span>
        	<span class="icon-bar"></span>
        	</a>
          <a class="brand" href="<?php echo BASE_URL_LOGO;?>"><?php if (JAK_LOGO_IGRID_TPL) echo '<img src="'.JAK_LOGO_IGRID_TPL.'" alt="logo" />';?><?php echo JAK_TITLE;?></a>
          <div class="nav-collapse collapse">
          <p class="navbar-text pull-right">
            <?php echo JAK_BCONTENT_IGRID_TPL;?>
          </p>
          	<?php include_once APP_PATH.'template/igrid/navbar.php';?>
          <?php if (isset($JAK_HOOK_HEADER) && is_array($JAK_HOOK_HEADER)) foreach($JAK_HOOK_HEADER as $hheader) { include_once APP_PATH.$hheader['phpcode']; } ?>
          </div><!--/.nav-collapse -->
        </div>
      </div>
    </div>
    
<!-- Import templates below header -->
<?php if (isset($JAK_HOOK_BELOW_HEADER) && is_array($JAK_HOOK_BELOW_HEADER)) foreach($JAK_HOOK_BELOW_HEADER as $bheader) { include_once APP_PATH.$bheader['phpcode']; } ?>

<!-- Main Container -->
<div class="container<?php if (JAK_FLUID_TPL == 'fluid') echo "-fluid";?>">

<!-- Main Row -->
<div class="row<?php if (JAK_FLUID_TPL == 'fluid') echo "-fluid";?>">

<!-- Sidebar if right -->
<?php if (isset($JAK_HOOK_SIDE_GRID) && (JAK_SIDEBAR_IGRID_TPL == "left" || $JAK_SIDEBAR_LOCATION)) { include_once APP_PATH.'template/igrid/sidebar.php'; } ?>

<div class="<?php echo ($JAK_HOOK_SIDE_GRID ? "span9" : "span12");?>">